      SUBROUTINE BCPINF(JINDEX,BTIME,PRESBC,PCOEFF)

C     *************************************************************************
C
C     BCPINF
C     ======
C
C     AUTHOR
C     ------
C     R.S.CANT  --  CAMBRIDGE UNIVERSITY ENGINEERING DEPARTMENT
C
C     CHANGE RECORD
C     -------------
C     10-MAY-2009:  CREATED
C     17-MAY-2015:  RSC CHANGE VARIABLE NAME FOR PRESSURE
C     
C     DESCRIPTION
C     -----------
C     DNS CODE HAMISH
C     IMPOSES BC FOR PRESSURE AT INFINITY
C
C     *************************************************************************


C     GLOBAL DATA
C     ===========
C     -------------------------------------------------------------------------
      INCLUDE 'com_hamish.h'
C     -------------------------------------------------------------------------


C     ARGUMENTS
C     =========
      DOUBLE PRECISION BTIME,PRESBC,PCOEFF
      INTEGER JINDEX


C     LOCAL DATA
C     ==========
      DOUBLE PRECISION BLTIME,XCOORD,YCOORD,ZCOORD
      INTEGER JBCELL,JBFACE


C     =========================================================================

C     BEGIN
C     =====

C     FIND BC COORDINATES
      BLTIME = BTIME
      XCOORD = BCOORD(1,JINDEX)
      YCOORD = BCOORD(2,JINDEX)
      ZCOORD = BCOORD(3,JINDEX)
      JBCELL = NBCCEL(JINDEX)
      JBFACE = NBCFAC(JINDEX)

C     PRESSURE AT INFINITY
      PRESBC = PBCINF(JBFACE)
      PCOEFF = PBCNST(JBFACE)

C     =========================================================================


      RETURN
      END
