      SUBROUTINE DFINIT
 
C     *************************************************************************
C
C     DFINIT
C     ======
C
C     AUTHOR
C     ------
C     R.S.CANT  --  CAMBRIDGE UNIVERSITY ENGINEERING DEPARTMENT
C
C     CHANGE RECORD
C     -------------
C     20-JUL-2008:  CREATED
C
C     DESCRIPTION
C     -----------
C     DNS CODE HAMISH
C     INITIALISES THE SPATIAL DISCRETISATION
C
C     *************************************************************************


C     GLOBAL DATA
C     ===========
C     -------------------------------------------------------------------------
      INCLUDE 'com_hamish.h'
C     -------------------------------------------------------------------------


C     PARAMETER
C     =========
      DOUBLE PRECISION ERFTOL 
      PARAMETER(ERFTOL = 1.0D-1)


C     LOCAL DATA
C     ==========
C      DOUBLE PRECISION RANGLE,COSRAN,SINRAN
      INTEGER JSPEC


C     BEGIN
C     =====

C     =========================================================================

C     SET SPATIAL MESH ADAPTION FLAG
C     ------------------------------
      FLADPM = .TRUE.
      IF(NSTMSW.EQ.0)FLADPM = .FALSE.

C     =========================================================================

C     INITIALISE THE NORMALISING VALUES FOR REFINEMENT/DEREFINEMENT DATA
C     ------------------------------------------------------------------
      ERDNRF = DRIN
      ERUNRF(1) = ONE
      IF(ABS(URIN).GT.ERFTOL)ERUNRF(1) = DRIN*ABS(URIN)
      ERUNRF(2) = ONE
      IF(ABS(VRIN).GT.ERFTOL)ERUNRF(2) = DRIN*ABS(VRIN)
      ERUNRF(3) = ONE
      IF(ABS(WRIN).GT.ERFTOL)ERUNRF(3) = DRIN*ABS(WRIN)
      ERENRF = ONE
      IF(ABS(ERIN).GT.ERFTOL)ERENRF = DRIN*ABS(ERIN)
      ERTNRF = TRIN
      ERPNRF = PRIN
      DO JSPEC = 1,NSPEC
        ERYNRF(JSPEC) = ONE
      ENDDO

      ERDNRF = ONE/ERDNRF
      ERUNRF(1) = ONE/ERUNRF(1)
      ERUNRF(2) = ONE/ERUNRF(2)
      ERUNRF(3) = ONE/ERUNRF(3)
      ERENRF = ONE/ERENRF
      ERTNRF = ONE/ERTNRF
      ERPNRF = ONE/ERPNRF

C      ERPNRF = 1.0E-2
      ERUNRF(1) = 1.0E-2

C     =========================================================================
C
CC     AXIS ROTATION FOR SECTORAL STENCIL CONSTRUCTION
CC     -----------------------------------------------
C
CC     SMALL ANGLE FOR ROTATIONS ABOUT ALL THREE AXES
C      RANGLE = 1.0D-2
C
C      COSRAN = COS(RANGLE)
C      SINRAN = SIN(RANGLE)
C
C      XPAXIS(1) = COSRAN*COSRAN
C      XPAXIS(2) = COSRAN*SINRAN
C      XPAXIS(3) = -SINRAN
C
C      YPAXIS(1) = COSRAN*SINRAN*(SINRAN-ONE)
C      YPAXIS(2) = SINRAN*SINRAN*SINRAN + COSRAN*COSRAN
C      YPAXIS(3) = COSRAN*SINRAN
C
C      ZPAXIS(1) = SINRAN*(COSRAN*COSRAN + SINRAN)
C      ZPAXIS(2) = COSRAN*SINRAN*(SINRAN-ONE)
C      ZPAXIS(3) = COSRAN*COSRAN
C
CC     =========================================================================
C
CC     ACTUAL AND MINIMUM-ALLOWED STENCIL SIZES
CC     ----------------------------------------
C
CC     ZEROTH DEGREE, FIRST ORDER
C      NPCAC1 = 0
C      NPCMN1 = 0
C
CC     FIRST DEGREE, SECOND ORDER
C      NPCAC2 = 3
C      NPCMN2 = 5
C
CC     SECOND DEGREE, THIRD ORDER
C      NPCAC3 = 9
C      NPCMN3 = 14
C
CC     THIRD DEGREE, FOURTH ORDER
C      NPCAC4 = 19
C      NPCMN4 = 29
C
CC     MIN REQUIRED NUMBER OF CELLS IN THE CENTRAL STENCIL
C      NRQSTN = 25
C
CC     MAX NUMBER OF LAYERS USED TO BUILD THE CENTRAL STENCIL
C      NRQLAY = 4
C
C     =========================================================================


      RETURN
      END
