      SUBROUTINE DIFTRB

C     *************************************************************************
C
C     DIFTRB
C     ======
C
C     AUTHOR
C     ------
C     R.S.CANT  --  CAMBRIDGE UNIVERSITY ENGINEERING DEPARTMENT
C
C     CHANGE RECORD
C     -------------
C     31-MAR-2011:  CREATED
C     
C     DESCRIPTION
C     -----------
C     DNS CODE HAMISH
C     COMPUTES RHS FOR DIFFUSIVE INITIALISATION OF TURBULENCE
C
C     *************************************************************************


C     GLOBAL DATA
C     ===========
C     -------------------------------------------------------------------------
      INCLUDE 'com_hamish.h'
C     -------------------------------------------------------------------------


C     LOCAL DATA
C     ==========
      INTEGER NFSTAT(NFACMX)
      INTEGER JCELL,ISCODE


C     =========================================================================

C     BEGIN
C     =====

C     =========================================================================

C     LOOP OVER ALL CELLS
C     -------------------
      DO JCELL = 1, NCELL

C       CELL INDEX
        ICELL = JCELL

C       =======================================================================

C       CELL STATUS CODE
C       ----------------
        IF(NSCODE(JCELL).EQ.NCLEAN)THEN

C         =====================================================================

C         SOLVABLE CELL: CLEAN
C         -------------

C         EVALUATE REFINEMENT/DEREFINEMENT DATA
C         -------------------------------------
          CALL DIFCEL

C         =====================================================================

        ELSEIF(NSCODE(JCELL).GT.NCLEAN)THEN

C         =====================================================================

C         SOLVABLE CELL: BC OR SIZE TRANSITION REQUIRED
C         -------------

C         CELL FACE CODES
C         ---------------
          ISCODE = NSCODE(JCELL)
          NFSTAT(NFWEST) = MOD(ISCODE,NSBASE)
          ISCODE = ISCODE/NSBASE
          NFSTAT(NFEAST) = MOD(ISCODE,NSBASE)
          ISCODE = ISCODE/NSBASE
          NFSTAT(NFSUTH) = MOD(ISCODE,NSBASE)
          ISCODE = ISCODE/NSBASE
          NFSTAT(NFNRTH) = MOD(ISCODE,NSBASE)
          ISCODE = ISCODE/NSBASE
          NFSTAT(NFLOWR) = MOD(ISCODE,NSBASE)
          ISCODE = ISCODE/NSBASE
          NFSTAT(NFUPPR) = MOD(ISCODE,NSBASE)

C         EVALUATE REFINEMENT/DEREFINEMENT DATA
C         -------------------------------------
          CALL DIFCBC(NFSTAT)

C         =====================================================================

        ELSE

C         =====================================================================

C         ERROR CONDITION - non-solvable cell
C         ---------------
          CALL ERHAND(24,8,4)

C         =====================================================================

        ENDIF
C       END OF CELL STATUS CODE

C       =======================================================================

      ENDDO
C     END OF LOOP OVER CELLS

C     =========================================================================


      RETURN
      END
