      PROGRAM HAMISH
 
C     *************************************************************************
C
C     HAMISH
C     ======
C
C     AUTHOR
C     ------
C     R.S.CANT  --  CAMBRIDGE UNIVERSITY ENGINEERING DEPARTMENT
C
C     CHANGE RECORD
C     -------------
C     01-JAN-2008:  CREATED
C
C     DESCRIPTION
C     -----------
C     THIS PROGRAM CARRIES OUT DIRECT NUMERICAL SIMULATION
C     OF COMPRESSIBLE TURBULENT FLOW AND COMBUSTION
C     USING ADAPTIVE METHODS IN TIME AND SPACE
C
C     PROVISION IS MADE FOR MULTIPLE SPECIES MASS FRACTIONS
C                           VARIABLE TRANSPORT PROPERTIES
C                           MULTIPLE STEP CHEMISTRY
C
C     REFERENCES
C     ==========
C     1) Tu, T., Yu, H., Ramirez-Guzman, L., Bielak, J., Ghattas, O.,
C        Ma, K-L, O'Hallaron, D.R.: "From Mesh Generation to Scientific
C        Visualisation; An End-to-End Approach to Parallel Supercomputing"
C        Supercomputing 2006, Tampa.
C
C     2) Shu, C-W., Osher, S.: "Efficient Implementation of Essentially
C        Non-Oscillatory Shock Capturing Schemes", J. Comput. Phys. 77,
C        439-471, 1988.
C
C     3) Ivan, L., Groth, C.P.T.: "High-order solution-adaptive central
C        essentially non-oscillatory (CENO) method for viscous flows",
C        J. Comput. Phys. 257, 830-862, 2014.
C
C     *************************************************************************


C     GLOBAL DATA
C     ===========
C     -------------------------------------------------------------------------
      INCLUDE 'com_hamish.h'
C     -------------------------------------------------------------------------


C     LOCAL DATA
C     ==========
C     NONE


C     BEGIN
C     =====

C     =========================================================================
 
C     INITIALISATION
C     ==============
C     INITIALISE THE CODE
      CALL STARTH

C     INITIALISE THE DATA
      CALL INDATA

C     RECORD INITIAL CONDITIONS
      CALL OUTPUT

C     =========================================================================

C     TIME STEP LOOP
C     ==============
      CALL STEPPR

C     =========================================================================
 
C     TERMINATION
C     ===========
      CALL FINISH

C     =========================================================================


      STOP
      END
