      SUBROUTINE ACEVAL(TLOCAL,YLOCAL,ACLOCL)

C     *************************************************************************
C
C     ACEVAL
C     ======
C
C     AUTHOR
C     ------
C     R.S.CANT  --  CAMBRIDGE UNIVERSITY ENGINEERING DEPARTMENT
C
C     CHANGE RECORD
C     -------------
C     25-SEP-2016:  CREATED
C
C     DESCRIPTION
C     -----------
C     DNS CODE HAMISH
C     COMPUTES SPEED OF SOUND
C
C     *************************************************************************


C     GLOBAL DATA
C     ===========
C     -------------------------------------------------------------------------
      INCLUDE 'com_hamish.h'
C     -------------------------------------------------------------------------


C     ARGUMENTS
C     =========
      DOUBLE PRECISION YLOCAL(NSPCMX)
      DOUBLE PRECISION TLOCAL,ACLOCL


C     LOCAL DATA
C     ==========
      DOUBLE PRECISION RGCMIX,CPCMIX,GAMMAR


C     =========================================================================

C     BEGIN
C     =====

C     =========================================================================

C     EVALUATE THE MIXTURE SPECIFIC HEAT CAPACITY AND MIXTURE GAS CONSTANT
C     --------------------------------------------------------------------
      CALL CPEVAL(TLOCAL,YLOCAL,CPCMIX,RGCMIX)

C     =========================================================================

C     RATIO OF SPECIFIC HEATS
C     -----------------------
C     TIMES MIXTURE GAS CONSTANT
      GAMMAR = CPCMIX*RGCMIX/(CPCMIX - RGCMIX)

C     =========================================================================

C     SPEED OF SOUND
C     --------------
      ACLOCL = SQRT(GAMMAR*TLOCAL)

C     =========================================================================


      RETURN
      END
