      SUBROUTINE ADMCHK
 
C     *************************************************************************
C
C     ADMCHK
C     ======
C
C     AUTHOR
C     ------
C     R.S.CANT  --  CAMBRIDGE UNIVERSITY ENGINEERING DEPARTMENT
C
C     CHANGE RECORD
C     -------------
C     16-AUG-2010:  CREATED
C
C     DESCRIPTION
C     -----------
C     DNS CODE HAMISH
C     CHECKS THE LIMITS ON MESH ADAPTION
C
C     *************************************************************************


C     GLOBAL DATA
C     ===========
C     -------------------------------------------------------------------------
      INCLUDE 'com_hamish.h'
C     -------------------------------------------------------------------------


C     LOCAL DATA
C     ==========
      INTEGER NEWCEL


C     BEGIN
C     =====

C     =========================================================================

C     CHECK THE LIMIT ON DEREFINEMENT
      IF(N2DREF.GT.NRDMAX)THEN
        N2DREF = NRDMAX
        CALL ERHAND(16,36,2)
      ENDIF

C     ------------------------------------------------------------------------- 

C     CHECK THE LIMIT ON REFINEMENT
      IF(N2REFN.GT.NRDMAX)THEN
        N2REFN = 0
        CALL ERHAND(16,37,2)
      ENDIF

C     ------------------------------------------------------------------------- 

C     CHECK THE LIMIT ON CELL COUNT
      NEWCEL = NCELL + (N2REFN-N2DREF)*NOFSET
      IF(NEWCEL.GT.NSIZMX)THEN
        N2REFN = 0
        CALL ERHAND(16,38,2)
      ENDIF

C     =========================================================================


      RETURN
      END
