      SUBROUTINE BCMASF(JINDEX,BTIME,YBCVAL)

C     *************************************************************************
C
C     BCMASF
C     ======
C
C     AUTHOR
C     ------
C     R.S.CANT  --  CAMBRIDGE UNIVERSITY ENGINEERING DEPARTMENT
C
C     CHANGE RECORD
C     -------------
C     10-MAY-2009:  CREATED
C     
C     DESCRIPTION
C     -----------
C     DNS CODE HAMISH
C     IMPOSES BC FOR SPECIES MASS FRACTIONS
C
C     *************************************************************************


C     GLOBAL DATA
C     ===========
C     -------------------------------------------------------------------------
      INCLUDE 'com_hamish.h'
C     -------------------------------------------------------------------------


C     ARGUMENTS
C     =========
      DOUBLE PRECISION YBCVAL(NSPCMX)
      DOUBLE PRECISION BTIME
      INTEGER JINDEX


C     LOCAL DATA
C     ==========
      DOUBLE PRECISION BLTIME,XCOORD,YCOORD,ZCOORD
      INTEGER JBCELL,JBFACE,LSPEC


C     =========================================================================

C     BEGIN
C     =====

C     FIND BC COORDINATES
      BLTIME = BTIME
      XCOORD = BCOORD(1,JINDEX)
      YCOORD = BCOORD(2,JINDEX)
      ZCOORD = BCOORD(3,JINDEX)
      JBCELL = NBCCEL(JINDEX)
      JBFACE = NBCFAC(JINDEX)

C     SET LOCAL MASS FRACTIONS
      DO LSPEC = 1,NSPEC
        YBCVAL(LSPEC) = YBCSET(LSPEC)
      ENDDO

C     =========================================================================


      RETURN
      END
