      SUBROUTINE CEVALL(XLOC,YLOC,ZLOC,DEVAL,UEVAL,EEVAL,YEVAL)
 
C     *************************************************************************
C
C     CEVALL
C     ======
C
C     AUTHOR
C     ------
C     R.S.CANT  --  CAMBRIDGE UNIVERSITY ENGINEERING DEPARTMENT
C
C     CHANGE RECORD
C     -------------
C     19-SEP-2014:  CREATED
C
C     DESCRIPTION
C     -----------
C     DNS CODE HAMISH
C     POLYNOMIAL EVALUATION
C     FOR ALL QUANTITIES
C
C     *************************************************************************


C     GLOBAL DATA
C     ===========
C     -------------------------------------------------------------------------
      INCLUDE 'com_hamish.h'
C     -------------------------------------------------------------------------


C     ARGUMENTS
C     =========
      DOUBLE PRECISION XLOC,YLOC,ZLOC
      DOUBLE PRECISION YEVAL(NSPCMX)
      DOUBLE PRECISION UEVAL(NCMPMX)
      DOUBLE PRECISION DEVAL,EEVAL


C     LOCAL DATA
C     ==========
      DOUBLE PRECISION PMONOM(NPCFMX)
      DOUBLE PRECISION STORE1,STORE2,STORE3,STORE4
      INTEGER NKPOLY,IPCOEF,IUCOMP,IYSPEC


C     BEGIN
C     =====

C     =========================================================================

C     BUILD THE MONOMIALS
C     -------------------
      PMONOM(1) = XLOC
      STORE1 = XLOC*XLOC
      PMONOM(2) = STORE1
      PMONOM(3) = STORE1*XLOC

      PMONOM(4) = YLOC
      STORE4 = YLOC*XLOC
      PMONOM(5) = STORE4
      STORE2 = YLOC*YLOC
      PMONOM(6) = STORE2
      PMONOM(7) = STORE1*YLOC
      PMONOM(8) = STORE2*XLOC
      PMONOM(9) = STORE2*YLOC

      PMONOM(10) = ZLOC
      PMONOM(11) = ZLOC*XLOC
      PMONOM(12) = ZLOC*YLOC
      STORE3 = ZLOC*ZLOC
      PMONOM(13) = STORE3
      PMONOM(14) = STORE1*ZLOC
      PMONOM(15) = STORE4*ZLOC
      PMONOM(16) = STORE3*XLOC
      PMONOM(17) = STORE2*ZLOC
      PMONOM(18) = STORE3*YLOC
      PMONOM(19) = STORE3*ZLOC

C     =========================================================================

C     ASSEMBLE THE POLYNOMIAL
C     -----------------------
      NKPOLY = NPCAC4


C     DENSITY
C     -------

C     SUM ALL THE TERMS
      DEVAL = PCOEFD(0)
      DO IPCOEF = 1, NKPOLY

        DEVAL = DEVAL + PCOEFD(IPCOEF)*PMONOM(IPCOEF)

      ENDDO
C     SUM ALL THE TERMS

C     -------------------------------------------------------------------------

C     VELOCITY
C     --------
      DO IUCOMP = 1,NCOMP

C       SUM ALL THE TERMS
        UEVAL(IUCOMP) = PCOEFU(0,IUCOMP)
        DO IPCOEF = 1, NKPOLY

          UEVAL(IUCOMP) = UEVAL(IUCOMP)
     +                  + PCOEFU(IPCOEF,IUCOMP)*PMONOM(IPCOEF)

        ENDDO
C       SUM ALL THE TERMS

      ENDDO

C     -------------------------------------------------------------------------

C     INTERNAL ENERGY
C     ---------------

C     SUM ALL THE TERMS
      EEVAL = PCOEFE(0)
      DO IPCOEF = 1, NKPOLY

        EEVAL = EEVAL + PCOEFE(IPCOEF)*PMONOM(IPCOEF)

      ENDDO
C     SUM ALL THE TERMS

C     -------------------------------------------------------------------------

C     SPECIES MASS FRACTION
C     ---------------------
      DO IYSPEC = 1,NSPEC

C       SUM ALL THE TERMS
        YEVAL(IYSPEC) = PCOEFY(0,IYSPEC)
        DO IPCOEF = 1, NKPOLY

          YEVAL(IYSPEC) = YEVAL(IYSPEC)
     +                  + PCOEFY(IPCOEF,IYSPEC)*PMONOM(IPCOEF)

        ENDDO
C       SUM ALL THE TERMS

      ENDDO

C     =========================================================================


      RETURN
      END
