C     HSIZES-------------------------------------------------------------------

C     MAX NUMBER OF PROCESSORS
      INTEGER NPROMX
      PARAMETER(NPROMX = 16)

C     MAX SIZE OF LOCAL ARRAYS
      INTEGER NSIZMX
      PARAMETER(NSIZMX = 100000)

C     MAX SIZE OF BC DATA LISTS
      INTEGER NBCMAX
      PARAMETER(NBCMAX = 10000)

C     MAX SIZE OF REFINEMENT/DEREFINEMENT CELL LISTS
      INTEGER NRDMAX
      PARAMETER(NRDMAX = 100000)

C     MAX SIZE OF REMOTE CELL LISTS
      INTEGER NREMAX
      PARAMETER(NREMAX = 100000)

CC     MAX NUMBER OF STENCILS
C      INTEGER NSECMX
C      PARAMETER(NSECMX = 6)
C
CC     MAX SIZE OF STENCILS
C      INTEGER NTSTMX,NLAYMX,NCSTMX,NSSTMX
C      PARAMETER(NTSTMX = 300, NLAYMX = 150, NCSTMX = 38, NSSTMX = 38)

C     MAX SIZE OF STENCILS
      INTEGER NTSTMX,NLAYMX,NCSTMX
      PARAMETER(NTSTMX = 300, NLAYMX = 150, NCSTMX = 100)

C     MAX NUMBER OF COEFFICIENTS FOR POLYNOMIAL RECONSTRUCTION
      INTEGER NPCFMX
      PARAMETER(NPCFMX = 19)

CC     MAX NUMBER OF ELEMENTS IN THE OSCILLATION INDICATOR MATRIX
C      INTEGER NBISMX
C      PARAMETER(NBISMX = 37)

C     MAX SIZE OF PARALLEL TRANSFER ARRAY
      INTEGER NPARMX
      PARAMETER(NPARMX = 100000)

C     MAX SIZE OF PARALLEL TRANSFER HALO
      INTEGER NHALMX
      PARAMETER(NHALMX = 2)

C     MAX SIZE OF OCTREE ARRAY
C     NOTE: MIN VALUE = NSIZMX/8
      INTEGER NOCTMX
      PARAMETER(NOCTMX = 25000)

C     MAX NUMBER OF LEVELS IN OCTREE
      INTEGER NLEVMX
      PARAMETER(NLEVMX = 18)

C     MAX SIZE OF CELL INDEX CODES
      INTEGER NINDMX,NIOCMX,NIBTMX
      PARAMETER(NINDMX = 2, NIOCMX = 20, NIBTMX = 64)

C     MAX SIZE OF PARTITION INTERVAL TABLE
C     MIN VALUE: NTLSIZ = NINDMX*(NPROMX+1)
      INTEGER NTLSIZ
      PARAMETER(NTLSIZ = 34)

C     MAX NUMBER OF DIMENSIONS, OCTANTS, VELOCITY COMPONENTS, FACES
      INTEGER NDIMAX,NOCSMX,NCMPMX,NFACMX
      PARAMETER(NDIMAX = 3, NOCSMX = 8, NCMPMX = 3, NFACMX = 6)

C     MAX NO OF SPECIES
      INTEGER NSPCMX
      PARAMETER(NSPCMX = 16)

C     MAX NO OF PHYSICAL QUANTITIES
      INTEGER NQNTMX
      PARAMETER(NQNTMX = 2 + NCMPMX + NSPCMX)

C     MAX NO OF GAUSS POINTS
      INTEGER NG3DMX,NG2DMX,NGPFMX
      PARAMETER(NG3DMX = 8, NG2DMX = 4, NGPFMX = 16)

C     MAX SIZE OF CELL FACE HASH TABLE
      INTEGER NFCEMX
      PARAMETER(NFCEMX = 100000)

C     HSIZES-------------------------------------------------------------------
C     CHEMIC-------------------------------------------------------------------

C     PARAMETERS
C     ==========
C     MAX NO OF REACTION STEPS
      INTEGER NSTPMX
      PARAMETER(NSTPMX = 35)

C     THERMODYNAMIC DATA
C     MAX NO OF TEMPERATURE INTERVALS, THERMO POLYNOMIAL COEFFICIENTS
      INTEGER NTINMX,NCOFMX
      PARAMETER(NTINMX = 2, NCOFMX = 11)
C     MAX NO OF TEMPERATURE COEFFICIENTS, DITTO MINUS ONE
      INTEGER NCTMAX,NCTMM1
      PARAMETER(NCTMAX = 9, NCTMM1 = NCTMAX-1)

C     CHEMICAL RATE DATA
C     MAX NO OF THIRD BODIES
      INTEGER NBDYMX
      PARAMETER(NBDYMX = 10)
C     MAX SIZE OF STEP SPECIES-LIST, STEP REACTANT-LIST
      INTEGER NSSMAX,NRSMAX
      PARAMETER(NSSMAX = 10, NRSMAX = 10)
C     MAX NO OF LINDEMANN STEPS
      INTEGER NLLMAX
      PARAMETER(NLLMAX = 10)

C     TRANSPORT COEFFICIENTS
      DOUBLE PRECISION ALAMDC,RLAMDA,TLAMDA
      PARAMETER(ALAMDC = 2.58D-5, RLAMDA = 7.0D-1, TLAMDA = 2.98D2)
      DOUBLE PRECISION PRANTL
      PARAMETER(PRANTL = 7.0D-1)

C     UNIVERSAL GAS CONSTANT
      DOUBLE PRECISION RGUNIV
      PARAMETER(RGUNIV = 8.3142D3)


C     CHEMICAL DATA
C     =============
      DOUBLE PRECISION AMOLCP(NCOFMX,NTINMX,NSPCMX)
      DOUBLE PRECISION AMOLGB(NCOFMX,NTINMX,NSPCMX)
      DOUBLE PRECISION AMASCP(NCOFMX,NTINMX,NSPCMX)
      DOUBLE PRECISION AMASCV(NCOFMX,NTINMX,NSPCMX)
      DOUBLE PRECISION AMASCT(NCOFMX,NTINMX,NSPCMX)
      DOUBLE PRECISION AMASCE(NCOFMX,NTINMX,NSPCMX)
      DOUBLE PRECISION AMASCH(NCOFMX,NTINMX,NSPCMX)
      DOUBLE PRECISION AMASCS(NCOFMX,NTINMX,NSPCMX)
      DOUBLE PRECISION TINTLO(NTINMX,NSPCMX),TINTHI(NTINMX,NSPCMX)
      DOUBLE PRECISION DIFFMU(NSSMAX,NSTPMX),DIFFMW(NSSMAX,NSTPMX)
      DOUBLE PRECISION CRSPEC(NSSMAX,NSTPMX),CPSPEC(NSSMAX,NSTPMX)
      DOUBLE PRECISION EFFY3B(NSPCMX,NBDYMX)
      DOUBLE PRECISION RPARAM(3,NSTPMX)
      DOUBLE PRECISION RCLIND(4,NLLMAX)
      DOUBLE PRECISION RCTROE(12,NLLMAX)
      DOUBLE PRECISION RCSRIF(8,NLLMAX)
      DOUBLE PRECISION WMOLAR(NSPCMX),OVWMOL(NSPCMX),RGSPEC(NSPCMX)
      DOUBLE PRECISION CLEWIS(NSPCMX),OLEWIS(NSPCMX),OLEWPR(NSPCMX)
      DOUBLE PRECISION PREFGB,ALAMDA
      DOUBLE PRECISION TBREAK,TWIDTH,OVTWID,OVTWRP

      INTEGER NSSPEC(NSSMAX,NSTPMX)
      INTEGER NRSPEC(NSSMAX,NSTPMX),NPSPEC(NSSMAX,NSTPMX)
      INTEGER NRCPEC(NSSMAX,NSTPMX),NPCPEC(NSSMAX,NSTPMX)
      INTEGER NCOFCP(NTINMX,NSPCMX)
      INTEGER NCPOLY(NTINMX,NSPCMX),NCPOM1(NTINMX,NSPCMX)
      INTEGER NCENTH(NTINMX,NSPCMX),NCENPY(NTINMX,NSPCMX)
      INTEGER NSSLEN(NSTPMX)
      INTEGER NRSLEN(NSTPMX),NPSLEN(NSTPMX)
      INTEGER NRCLEN(NSTPMX),NPCLEN(NSTPMX)
      INTEGER MBLIST(NSTPMX)
      INTEGER MGLIST(NSTPMX)
      INTEGER MLLIST(NSTPMX)
      INTEGER MTLIST(NSTPMX)
      INTEGER MSLIST(NSTPMX)
      INTEGER NTINT(NSPCMX)
      INTEGER NSPM1,NBODY,NGIBB,NLIND,NTROE,NSRIF
 
C     MAX LENGTH OF SPECIES SYMBOL STRINGS
      INTEGER NSPSTR
      PARAMETER(NSPSTR = 10)
C     SPECIES AND THIRD BODY STRINGS MUST BE DECLARED AS CHARACTER*NSPSTR
      CHARACTER*10 SPCSYM(NSPCMX)
      CHARACTER*10 BDYSYM(NSPCMX)

      COMMON/CHEMIC/AMOLCP,AMOLGB,AMASCP,AMASCV,
     +              AMASCT,AMASCE,AMASCH,AMASCS,
     +              TINTLO,TINTHI,
     +              DIFFMU,DIFFMW,CRSPEC,CPSPEC,EFFY3B,
     +              RPARAM,RCLIND,RCTROE,RCSRIF,
     +              WMOLAR,OVWMOL,RGSPEC,CLEWIS,OLEWIS,OLEWPR,
     +              PREFGB,ALAMDA,
     +              TBREAK,TWIDTH,OVTWID,OVTWRP,
     +              NSSPEC,NRSPEC,NPSPEC,NRCPEC,NPCPEC,
     +              NCOFCP,NCPOLY,NCPOM1,NCENTH,NCENPY,
     +              NSSLEN,NRSLEN,NPSLEN,NRCLEN,NPCLEN,
     +              MBLIST,MGLIST,MLLIST,MTLIST,MSLIST,
     +              NTINT,
     +              NSPM1,NBODY,NGIBB,NLIND,NTROE,NSRIF,
     +              SPCSYM,BDYSYM

C     CHEMIC-------------------------------------------------------------------
C     ACSIZE-------------------------------------------------------------------

C     ACTUAL SIZES
      INTEGER NPROC,NCELL,NLEVL,NDIMS,NCOMP,NFACE,NFSUB,NSCTR,
     +        NSPEC,NSTEP,NVGPT,NFGPT

      COMMON/ACSIZE/NPROC,NCELL,NLEVL,NDIMS,NCOMP,NFACE,NFSUB,
     +              NSCTR,NSPEC,NSTEP,NVGPT,NFGPT

C     ACSIZE-------------------------------------------------------------------
C     PARAMS-------------------------------------------------------------------

C     PHYSICAL AND NUMERICAL PARAMETERS

C     MAXIMUM INTEGER VALUE (32-BIT SIGNED INTEGER)
      INTEGER MAXINT
      PARAMETER(MAXINT = 2147483647)

C     MASS FRACTION TOLERANCE
      DOUBLE PRECISION YTOLER
      PARAMETER(YTOLER = 1.0E-10)

C     NUMBERS
      DOUBLE PRECISION ZERO,ONE,TWO,THREE,FOUR,SIX,TEN,
     +                 HALF,THRF,THRD,TTHD,FTHD,QRTR,SXTH,EIGHTH,TWLFTH
      PARAMETER(ZERO=0.0D0, ONE=1.0D0, TWO=2.0D0, THREE=3.0D0,
     +          FOUR=4.0D0, SIX=6.0D0, TEN = 1.0D1)
      PARAMETER(HALF=ONE/TWO,  THRF=THREE*HALF,  THRD=ONE/THREE,
     +          TTHD=TWO*THRD, FTHD=TWO*TTHD,    QRTR=ONE/FOUR,
     +          SXTH=THRD/TWO, EIGHTH=QRTR*HALF, TWLFTH = THRD*QRTR)

C     FILE I/O UNIT NUMBERS
      INTEGER NCCONT,NCCHEM,NCBCIO,NCDMPI,NCDMPO,NCREPT,NCRESO,NCSTAT
      PARAMETER(NCCONT = 1, NCCHEM = 2, NCBCIO = 3, NCDMPI = 4,
     +          NCDMPO = 7, NCREPT = 8, NCRESO = 8, NCSTAT = 8)

C     RANDOM NUMBER GENERATOR STATUS ARRAY SIZES
      INTEGER NRNUMX,NRNGMX
      PARAMETER(NRNUMX = 100, NRNGMX = 102)

C     PHYSICAL AND NUMERICAL DATA
      DOUBLE PRECISION YRIN(NSPCMX)
      DOUBLE PRECISION PRIN,TRIN,SRIN,DRIN,URIN,VRIN,WRIN,ERIN
      DOUBLE PRECISION PREFER
      DOUBLE PRECISION UPRIME(NCMPMX)
      DOUBLE PRECISION XGDLEN,YGDLEN,ZGDLEN
      DOUBLE PRECISION XGPHYL,XGPHYR,YGPHYL,YGPHYR,ZGPHYL,ZGPHYR
      DOUBLE PRECISION OVPROC
      DOUBLE PRECISION RKTIME,ETIME,TSTEP
      DOUBLE PRECISION PI,ROOTPI,TWOPI,CLNTEN,RLNTWO
      DOUBLE PRECISION RSIGN(NFACMX),RDELTA(NCMPMX,NCMPMX)
      DOUBLE PRECISION OFFSGN(NCMPMX,0:7)
      INTEGER MPMIN(NCMPMX,0:NLEVMX),MPMAX(NCMPMX,0:NLEVMX)
      INTEGER MATINC(NCMPMX,NFACMX)
      INTEGER MAPOPP(NFACMX)
      INTEGER MCFACE(2,4,NFACMX)
      INTEGER MCFCON(2,4)
      INTEGER MCQTBL(0:7,NFACMX)
      INTEGER MNGRAD(NCMPMX,0:7)
      INTEGER MCFTBL(4,NFACMX)
      INTEGER MDIRN(NFACMX),MSIGN(NFACMX),MCSIGN(NFACMX)
      INTEGER MFACE(NCMPMX,2)
      INTEGER MNVIST(2,NCMPMX)
      INTEGER ICELL,ITIME,NTIME,NTIME1,NTIME2,NSTPSW,
     +        INTURB,INMESH,INFLAM,ITSEED,
     +        NXGREQ,NLEVRQ,NLEVBQ,NSTMSW,NBLEVL,NSPREQ,NNCODE,NPRM1,
     +        NTDUMP,NDIFMT,NDOFMT,NROFMT,NTREPT,
     +        ITSTAT,NTSTAT,NTRESO,ICFLAG,IDFLAG,IDTIME,IRFLAG,
     +        NCONT1,NCONT2,NCONT3,NCONT4,NCONT5,NCONT6
      CHARACTER*80 FNCONT,FNCHEM,FNBCIO,FNREPT,FNRESO,FNSTAT,FNDMPO(2)
      CHARACTER*80 CLDASH,CLSTAR
      CHARACTER*6 FNPROC,FNFLAG
      CHARACTER*4 FNREST,FNXDAT,FNXRES
      LOGICAL FLHAND(NFACMX)
      LOGICAL FLADPT,FLADPM

      COMMON/PARAMS/
     +       YRIN,PRIN,TRIN,SRIN,DRIN,URIN,VRIN,WRIN,ERIN,
     +       PREFER,
     +       UPRIME,
     +       XGDLEN,YGDLEN,ZGDLEN,
     +       XGPHYL,XGPHYR,YGPHYL,YGPHYR,ZGPHYL,ZGPHYR,
     +       OVPROC,
     +       RKTIME,ETIME,TSTEP,PI,ROOTPI,TWOPI,CLNTEN,RLNTWO,
     +       RSIGN,RDELTA,OFFSGN,
     +       MPMIN,MPMAX,
     +       MATINC,MAPOPP,MCFACE,MCFCON,MCQTBL,MNGRAD,MCFTBL,
     +       MDIRN,MSIGN,MCSIGN,MFACE,MNVIST,
     +       ICELL,ITIME,NTIME,NTIME1,NTIME2,NSTPSW,
     +       INTURB,INMESH,INFLAM,ITSEED,
     +       NXGREQ,NLEVRQ,NLEVBQ,NSTMSW,NBLEVL,NSPREQ,NNCODE,NPRM1,
     +       NTDUMP,NDIFMT,NDOFMT,NROFMT,NTREPT,
     +       ITSTAT,NTSTAT,NTRESO,ICFLAG,IDFLAG,IDTIME,IRFLAG,
     +       NCONT1,NCONT2,NCONT3,NCONT4,NCONT5,NCONT6,
     +       FNCONT,FNCHEM,FNBCIO,FNREPT,FNRESO,FNSTAT,FNDMPO,
     +       CLDASH,CLSTAR,
     +       FNPROC,FNFLAG,FNREST,FNXDAT,FNXRES,
     +       FLHAND,
     +       FLADPT,FLADPM

C     PARAMS-------------------------------------------------------------------
C     RUNKUT-------------------------------------------------------------------

C     RUNGE-KUTTA PARAMETERS
      INTEGER NRKMAX
      PARAMETER(NRKMAX = 3)

      DOUBLE PRECISION RKLHS(NRKMAX),RKRHS(NRKMAX)
      DOUBLE PRECISION RKSAV(NRKMAX),RKRUN(NRKMAX)
      DOUBLE PRECISION RKERR(NRKMAX),RKTIM(NRKMAX),RKDIF(NRKMAX)
      DOUBLE PRECISION RKLHC(NRKMAX),RKRHC(NRKMAX)
      DOUBLE PRECISION RKSVC(NRKMAX),RKRNC(NRKMAX)
      DOUBLE PRECISION RKERC(NRKMAX),RKTMC(NRKMAX),RKDFC(NRKMAX)
      DOUBLE PRECISION CTMULT,CTALPH,CTBETA,CTGAMA
      DOUBLE PRECISION ERRTOL,ERRLOW,TRMIN,TRMAX,TSMIN,TSMAX
      DOUBLE PRECISION ERROLD,ERRLDR
      DOUBLE PRECISION ERDTOT,ERUTOT,ERVTOT,ERWTOT,ERETOT
      DOUBLE PRECISION ERDNRM,ERUNRM,ERVNRM,ERWNRM,ERENRM
      DOUBLE PRECISION ERYTOT(NSPCMX),ERYNRM(NSPCMX)
      INTEGER IRKSTP,NRKSTP,NRKSM1
      INTEGER JERLOC,JINDIC

      COMMON/RUNKUT/RKLHS,RKRHS,RKSAV,RKRUN,RKERR,RKTIM,RKDIF,
     +              RKLHC,RKRHC,RKSVC,RKRNC,RKERC,RKTMC,RKDFC,
     +              CTMULT,CTALPH,CTBETA,CTGAMA,
     +              ERRTOL,ERRLOW,TRMIN,TRMAX,TSMIN,TSMAX,
     +              ERROLD,ERRLDR,
     +              ERDTOT,ERUTOT,ERVTOT,ERWTOT,ERETOT,ERYTOT,
     +              ERDNRM,ERUNRM,ERVNRM,ERWNRM,ERENRM,ERYNRM,
     +              IRKSTP,NRKSTP,NRKSM1,
     +              JERLOC,JINDIC

C     RUNKUT-------------------------------------------------------------------
C     PARDAT-------------------------------------------------------------------

C     PARALLEL TRANSFER ARRAY
      DOUBLE PRECISION PARRAY(NPARMX)

C     LOCAL PROCESSOR ID
      INTEGER IPROC

      COMMON/PARDAT/PARRAY,IPROC

C     PARDAT-------------------------------------------------------------------
C     PRVARS-------------------------------------------------------------------

C     PRINCIPAL VARIABLES
      DOUBLE PRECISION YRUN(NSPCMX,NSIZMX),
     +                 URUN(NCMPMX,NSIZMX),
     +                 DRUN(NSIZMX),ERUN(NSIZMX)
     
      COMMON/PRVARS/YRUN,URUN,DRUN,ERUN

C     PRVARS-------------------------------------------------------------------
C     TIMRHS-------------------------------------------------------------------

C     TIME-STEPPING RHS TERMS
      DOUBLE PRECISION YRHS(NSPCMX,NSIZMX),
     +                 URHS(NCMPMX,NSIZMX),
     +                 DRHS(NSIZMX),ERHS(NSIZMX)
     
      COMMON/TIMRHS/YRHS,URHS,DRHS,ERHS

C     TIMRHS-------------------------------------------------------------------
C     TIMERR-------------------------------------------------------------------

C     TIME-STEPPING ERROR ARRAYS
      DOUBLE PRECISION YERR(NSPCMX,NSIZMX),
     +                 UERR(NCMPMX,NSIZMX),
     +                 DERR(NSIZMX),EERR(NSIZMX)
     
      COMMON/TIMERR/YERR,UERR,DERR,EERR

C     TIMERR-------------------------------------------------------------------
C     TIMSAV-------------------------------------------------------------------

C     TIME-STEPPING SAVED-SOLUTION ARRAYS
      DOUBLE PRECISION YSAV(NSPCMX,NSIZMX),
     +                 USAV(NCMPMX,NSIZMX),
     +                 DSAV(NSIZMX),ESAV(NSIZMX)
     
      COMMON/TIMSAV/YSAV,USAV,DSAV,ESAV

C     TIMSAV-------------------------------------------------------------------
C     PRIMVR-------------------------------------------------------------------

C     PRIMITIVE VARIABLES
      DOUBLE PRECISION YSOR(NSPCMX,NSIZMX),
     +                 USOR(NCMPMX,NSIZMX),
     +                 DSOR(NSIZMX),ESOR(NSIZMX)

      COMMON/PRIMVR/YSOR,USOR,DSOR,ESOR

C     PRIMVR-------------------------------------------------------------------
C     SECVAR-------------------------------------------------------------------

C     SECONDARY VARIABLES
      DOUBLE PRECISION SRUN(NSIZMX),PRUN(NSIZMX),TRUN(NSIZMX)

      COMMON/SECVAR/SRUN,PRUN,TRUN

C     SECVAR-------------------------------------------------------------------
C     LOCTRE-------------------------------------------------------------------

C     OCTREE OCTANT ATTRIBUTE CODES
      CHARACTER*1 CHUNST,CHNRML,CHOUTC,CHPARL,CHTWIG,CHEROR
      PARAMETER(CHUNST = 'U', CHNRML = 'N', CHOUTC = 'O',
     +          CHPARL = 'P', CHTWIG = 'T', CHEROR = 'E')

C     LOCAL OCTREE OCTANT ARRAYS
      INTEGER NOCPAR(NOCTMX)
      INTEGER NOCHLD(0:7,NOCTMX)
      CHARACTER*1 COCODE(0:7,NOCTMX)

C     LOCAL OCTREE HIGH WATER MARK
      INTEGER NOCHWM

      COMMON/LOCTRE/NOCPAR,NOCHLD,NOCHWM,COCODE

C     LOCTRE-------------------------------------------------------------------
C     CELDAT-------------------------------------------------------------------

C     CELL STATUS PARAMETERS
      INTEGER NSBASE
      INTEGER NCLEAN,NCOUTR,NCHALO
      INTEGER N2HTOH,NHTO2H,NBCOND
      PARAMETER(NSBASE = 35)
      PARAMETER(NCLEAN = 0, NCOUTR = -1, NCHALO = -2)
      PARAMETER(N2HTOH = 34, NHTO2H = 30, NBCOND = 1)

C     CELL FACE DISCRETISATION CODES
      INTEGER NDNULL,ND2PTC,ND3PTL,ND3PTR,ND4PTC
      PARAMETER(NDNULL = 0, ND2PTC = 1)
      PARAMETER(ND3PTL = 2, ND3PTR = 3, ND4PTC = 4) 

C     CELL FACE PARAMETERS
      INTEGER NFWEST,NFEAST,NFSUTH,NFNRTH,NFLOWR,NFUPPR
      PARAMETER(NFWEST = 1, NFEAST = 2,
     +          NFSUTH = 3, NFNRTH = 4,
     +          NFLOWR = 5, NFUPPR = 6)

C     CELL GLOBAL DATA
      DOUBLE PRECISION XCENTR(NSIZMX),YCENTR(NSIZMX),ZCENTR(NSIZMX)
      DOUBLE PRECISION HCSIZE(0:NLEVMX),OVSIZE(0:NLEVMX)
      INTEGER NXDOOR(NFACMX,NSIZMX),NEFACE(NFACMX,NSIZMX)
      INTEGER NMCODE(NINDMX,NSIZMX)
      INTEGER NSCODE(NSIZMX)
      INTEGER NDISCO(NSIZMX)
      INTEGER NPARNT(NSIZMX)
      INTEGER NLEVEL(NSIZMX)
      INTEGER NRQSTN,NRQLAY
      INTEGER NLVHWM

      COMMON/CELDAT/XCENTR,YCENTR,ZCENTR,
     +              HCSIZE,OVSIZE,NXDOOR,NEFACE,
     +              NMCODE,NSCODE,NDISCO,NPARNT,NLEVEL,
     +              NRQSTN,NRQLAY,NLVHWM

C     CELDAT-------------------------------------------------------------------
C     CELSSC-------------------------------------------------------------------

C     STENCIL CONSTRUCTION DATA
      DOUBLE PRECISION XPAXIS(NCMPMX),YPAXIS(NCMPMX),ZPAXIS(NCMPMX)
      INTEGER NPCAC1,NPCAC2,NPCAC3,NPCAC4
      INTEGER NPCMN1,NPCMN2,NPCMN3,NPCMN4,NCSTRQ

      COMMON/CELSSC/XPAXIS,YPAXIS,ZPAXIS,
     +              NPCAC1,NPCAC2,NPCAC3,NPCAC4,
     +              NPCMN1,NPCMN2,NPCMN3,NPCMN4,NCSTRQ


C     CELSSC-------------------------------------------------------------------
C     CELSTN-------------------------------------------------------------------

CC     CELL STENCIL DATA
C      INTEGER NSSTEN(NSSTMX,0:NFACMX,NSIZMX)
C      INTEGER NOSSTN(0:NFACMX,NSIZMX),NKSSTN(0:NFACMX,NSIZMX)

C     CELL STENCIL DATA
      INTEGER NSSTEN(NCSTMX,NSIZMX)
      INTEGER NOSSTN(NSIZMX)

      COMMON/CELSTN/NSSTEN,NOSSTN

C     CELL LOCAL STENCIL DATA
      INTEGER N2STEN(NCSTMX)
      INTEGER N2SSTN,N2FSTN

      COMMON/CELSTL/N2STEN,N2SSTN,N2FSTN

C     CELSTN-------------------------------------------------------------------
C     REMOTE-------------------------------------------------------------------

C     REMOTE CELL DATA
      INTEGER NRCLOC(NREMAX),NRRLOC(NREMAX)
      INTEGER N2SEND(NPROMX),N2RECV(NPROMX)
      INTEGER NCSEND(NPROMX),NCRECV(NPROMX)
      INTEGER NRCELL,NRRCEL

      INTEGER NCELP1,NCELHW

C     PARTITION INTERVAL TABLE
      INTEGER NTABLE(NINDMX,0:NPROMX)

      COMMON/REMOTE/NRCLOC,NRRLOC,
     +              N2SEND,N2RECV,NCSEND,NCRECV,
     +              NRCELL,NRRCEL
      COMMON/RCINDX/NCELP1,NCELHW
      COMMON/PARTAB/NTABLE

C     REMOTE-------------------------------------------------------------------
C     REMFAC-------------------------------------------------------------------

C     REMOTE CELL FACE DATA
      INTEGER NRNLOC(NREMAX),NRNFAC(NREMAX),NRNCOD(NREMAX)
      INTEGER NFSEND(NPROMX),NFRECV(NPROMX)
      INTEGER NGSEND(NPROMX),NGRECV(NPROMX)
      INTEGER NRNCEL

      COMMON/REMFAC/NRNLOC,NRNFAC,NRNCOD,
     +              NFSEND,NFRECV,NGSEND,NGRECV,
     +              NRNCEL

C     REMFAC-------------------------------------------------------------------
C     CELFAC-------------------------------------------------------------------

C     CELL FACE DATA
      DOUBLE PRECISION YEFACE(NSPCMX,NG2DMX,NFCEMX)
      DOUBLE PRECISION YDFACE(NSPCMX,NG2DMX,NFCEMX)
      DOUBLE PRECISION YMFACE(NSPCMX,NG2DMX,NFCEMX)
      DOUBLE PRECISION UEFACE(NCMPMX,NG2DMX,NFCEMX)
      DOUBLE PRECISION UDFACE(NCMPMX,NG2DMX,NFCEMX)
      DOUBLE PRECISION GPFACE(NCMPMX,NG2DMX,NFCEMX)
      DOUBLE PRECISION DEFACE(NG2DMX,NFCEMX),DMFACE(NG2DMX,NFCEMX)
      DOUBLE PRECISION TEFACE(NG2DMX,NFCEMX),TDFACE(NG2DMX,NFCEMX)
      DOUBLE PRECISION TMFACE(NG2DMX,NFCEMX)
      DOUBLE PRECISION EEFACE(NG2DMX,NFCEMX)
      DOUBLE PRECISION PEFACE(NG2DMX,NFCEMX),PMFACE(NG2DMX,NFCEMX)
      DOUBLE PRECISION CPFACE(NG2DMX,NFCEMX),RGFACE(NG2DMX,NFCEMX)
      INTEGER NLFACE(NFCEMX),NFSTAK(NFCEMX)
      INTEGER ISTACK

      COMMON/CELFAC/YEFACE,YDFACE,YMFACE,UEFACE,UDFACE,GPFACE,
     +       DEFACE,DMFACE,TEFACE,TDFACE,TMFACE,EEFACE,PEFACE,PMFACE,
     +       CPFACE,RGFACE,
     +       NLFACE,NFSTAK,ISTACK

C     CELFAC-------------------------------------------------------------------
C     CELPOL-------------------------------------------------------------------

C     CELL POLYNOMIAL COEFFICIENT DATA
      DOUBLE PRECISION PCOEFY(0:NPCFMX,NSPCMX)
      DOUBLE PRECISION PCOEFU(0:NPCFMX,NCMPMX)
      DOUBLE PRECISION PCOEFD(0:NPCFMX),PCOEFE(0:NPCFMX)
      DOUBLE PRECISION PCOEFT(0:NPCFMX),PCOEFP(0:NPCFMX)

      COMMON/CELCPC/PCOEFY,PCOEFU,PCOEFD,PCOEFE,PCOEFT,PCOEFP

      DOUBLE PRECISION PCODFY(0:NPCFMX,NSPCMX)
      DOUBLE PRECISION PCODFU(0:NPCFMX,NCMPMX)
      DOUBLE PRECISION PCODFD(0:NPCFMX),PCODFE(0:NPCFMX)
      DOUBLE PRECISION PCODFT(0:NPCFMX),PCODFP(0:NPCFMX)

      COMMON/CELDPC/PCODFY,PCODFU,PCODFD,PCODFE,PCODFT,PCODFP

C     RENO LIMITER FLAG
      LOGICAL FLMNOT
      COMMON/CELSMI/FLMNOT

C     RENO PARAMETERS
      DOUBLE PRECISION EPATOL,EPSMTH,SMINIM
      PARAMETER(EPATOL = 1.0D-30, EPSMTH = 1.0D-8, SMINIM = 1.0D5)

CC     WENO PARAMETERS
C      DOUBLE PRECISION DCLINW,DSLINW,EPSFAC,PWFACT
C      PARAMETER(DCLINW = 1.0D3,  DSLINW = 1.0D0)
C      PARAMETER(EPSFAC = 1.0D-6, PWFACT = 4.0D0)
C
CC     OSCILLATION INDICATOR MATRIX
C      DOUBLE PRECISION BCOEFF(NBISMX,NLEVMX)
C      DOUBLE PRECISION DLINWT(NSECMX)
C      INTEGER INDSMP(NBISMX),INDSMQ(NBISMX)
C      INTEGER NSMND1,NSMNP1,NSMIND
C      
C      COMMON/CELBIS/BCOEFF,DLINWT,INDSMP,INDSMQ,NSMND1,NSMNP1,NSMIND
C
CC     SMOOTHNESS INDICATORS
C      DOUBLE PRECISION SMINDY(NSPCMX,0:NSECMX)
C      DOUBLE PRECISION SMINDU(NCMPMX,0:NSECMX)
C      DOUBLE PRECISION SMINDD(0:NSECMX),SMINDT(0:NSECMX)
C
C      COMMON/CELSMI/SMINDY,SMINDU,SMINDD,SMINDT

C     CELPOL-------------------------------------------------------------------
C     CGPLOC-------------------------------------------------------------------

C     CELL GAUSS POINT LOCATION DATA
      DOUBLE PRECISION GAUSFX(NG2DMX,NFACMX),GAUSFY(NG2DMX,NFACMX)
      DOUBLE PRECISION GAUSFZ(NG2DMX,NFACMX)
      DOUBLE PRECISION GAUSVX(NG3DMX),GAUSVY(NG3DMX),GAUSVZ(NG3DMX)
      DOUBLE PRECISION SUBFAX(NG2DMX,NFACMX),SUBFAY(NG2DMX,NFACMX)
      DOUBLE PRECISION SUBFAZ(NG2DMX,NFACMX)

      COMMON/CGCLOC/GAUSFX,GAUSFY,GAUSFZ,GAUSVX,GAUSVY,GAUSVZ,
     +              SUBFAX,SUBFAY,SUBFAZ

C     CGPLOC-------------------------------------------------------------------
C     CGPHYD-------------------------------------------------------------------

C     CELL GAUSS POINT PHYSICAL DATA
      DOUBLE PRECISION YGVALF(NSPCMX,NGPFMX,NFACMX)
      DOUBLE PRECISION YGRADF(NSPCMX,NGPFMX,NFACMX)
      DOUBLE PRECISION YMVALF(NSPCMX,NGPFMX,NFACMX)
      DOUBLE PRECISION UGVALF(NCMPMX,NGPFMX,NFACMX)
      DOUBLE PRECISION UGRADF(NCMPMX,NGPFMX,NFACMX)
      DOUBLE PRECISION GPLOCF(NCMPMX,NGPFMX,NFACMX)
      DOUBLE PRECISION DGVALF(NGPFMX,NFACMX),DMVALF(NGPFMX,NFACMX)
      DOUBLE PRECISION TGVALF(NGPFMX,NFACMX),TGRADF(NGPFMX,NFACMX)
      DOUBLE PRECISION TMVALF(NGPFMX,NFACMX)
      DOUBLE PRECISION PGVALF(NGPFMX,NFACMX),PMVALF(NGPFMX,NFACMX)
      DOUBLE PRECISION EGVALF(NGPFMX,NFACMX),EMVALF(NGPFMX,NFACMX)
      DOUBLE PRECISION CPVALF(NGPFMX,NFACMX),RGVALF(NGPFMX,NFACMX)
      DOUBLE PRECISION YGVALS(NSPCMX,NG3DMX)
      DOUBLE PRECISION UGVALS(NCMPMX,NG3DMX)
      DOUBLE PRECISION DGVALS(NG3DMX),TGVALS(NG3DMX),PGVALS(NG3DMX)
      DOUBLE PRECISION CPVALS(NG3DMX),RGVALS(NG3DMX)
      DOUBLE PRECISION GPFVOL,GPFLUX
      INTEGER NGPFAC,NGPVOL

      COMMON/CGPHYD/YGVALF,YGRADF,YMVALF,UGVALF,UGRADF,GPLOCF,
     +              DGVALF,DMVALF,TGVALF,TGRADF,TMVALF,PGVALF,PMVALF,
     +              EGVALF,EMVALF,CPVALF,RGVALF,
     +              YGVALS,UGVALS,DGVALS,TGVALS,PGVALS,CPVALS,RGVALS,
     +              GPFVOL,GPFLUX,
     +              NGPFAC,NGPVOL

C     CGPHYD-------------------------------------------------------------------
C     CELREF-------------------------------------------------------------------

C     CELL REFINEMENT STATUS PARAMETERS
      INTEGER NRNULL,NRDPAR,NRDCHL,NRDRTN,NRRPAR,NRRCHL
      PARAMETER(NRNULL = 0, NRDPAR = 1, NRDCHL = 2, NRDRTN = 3,
     +                      NRRPAR = 4, NRRCHL = 5)

C     CELL REFINEMENT DATA
      DOUBLE PRECISION ERYREF(NSPCMX)
      DOUBLE PRECISION ERUREF(NCMPMX)
      DOUBLE PRECISION ERDREF,EREREF,ERPREF,ERTREF,ERMREF

      COMMON/CELREF/ERYREF,ERUREF,ERDREF,EREREF,ERPREF,ERTREF,ERMREF

      DOUBLE PRECISION ERYNRF(NSPCMX)
      DOUBLE PRECISION ERUNRF(NCMPMX)
      DOUBLE PRECISION ERDNRF,ERENRF,ERPNRF,ERTNRF

      COMMON/CELNRF/ERYNRF,ERUNRF,ERDNRF,ERENRF,ERPNRF,ERTNRF

      DOUBLE PRECISION SFREFY(NSPCMX)
      DOUBLE PRECISION SFREFU(NCMPMX)
      DOUBLE PRECISION SFREFD,SFREFT,SFREFS
      DOUBLE PRECISION DDETOL,DRETOL

      COMMON/CELRSF/SFREFY,SFREFU,SFREFD,SFREFT,SFREFS,DRETOL,DDETOL

      DOUBLE PRECISION DREFAV
      INTEGER NOFSET,NOFSP1
      COMMON/CELRDF/DREFAV,NOFSET,NOFSP1

      INTEGER NINDDR(NRDMAX),NINDRR(NRDMAX)
      INTEGER N2DREF,N2REFN,NTMINT,NMLMIN,NMLMAX
      COMMON/CELNUM/NINDDR,NINDRR,N2DREF,N2REFN,NTMINT,NMLMIN,NMLMAX

      INTEGER NRSTAT(NSIZMX),NCOCEL(NSIZMX)
      COMMON/CELINK/NRSTAT,NCOCEL

C     CELREF-------------------------------------------------------------------
C     ESPCOM-------------------------------------------------------------------

C     COMMON DATA FOR TURBULENCE GENERATOR
C     ------------------------------------

C     GENERAL TURBULENCE PARAMETERS
C     -----------------------------
C     NUMBER OF TURBULENCE PARAMETERS
      INTEGER NSPARM
      PARAMETER(NSPARM = 7)

C     SPECTRUM PARAMETERS
      DOUBLE PRECISION SPARAM(NSPARM)

      COMMON/ESPCOM/SPARAM

C     ESPCOM-------------------------------------------------------------------
C     NSBCCP-------------------------------------------------------------------

C     BC TYPE PARAMETERS
      INTEGER NSNULL,NSPERI,
     +        NSBCI1,NSBCI2,NSBCI3,NSBCI4,
     +        NSBCO1,NSBCO2,NSBCO3,NSBCO4,
     +        NSBCW1,NSBCW2,NSBCW3,NSBCW4
      PARAMETER(NSNULL = 0,  NSPERI = 1,
     +          NSBCI1 = 11, NSBCI2 = 12, NSBCI3 = 13, NSBCI4 = 14,
     +          NSBCO1 = 21, NSBCO2 = 22, NSBCO3 = 23, NSBCO4 = 24,
     +          NSBCW1 = 25, NSBCW2 = 26, NSBCW3 = 27, NSBCW4 = 28)

C     BC NUMBER OF PARAMETERS
      INTEGER NBCPRI,NBCPRR
      PARAMETER(NBCPRI = 4, NBCPRR = 4)

C     GLOBAL BC TYPE VARIABLES
      INTEGER NGLOBC(NFACMX)
      
C     BC DATA
      DOUBLE PRECISION BCOORD(NCMPMX,NBCMAX)
      DOUBLE PRECISION RGBPRM(NBCPRR,NFACMX)
      DOUBLE PRECISION YBCSET(NSPCMX)
      DOUBLE PRECISION PBCINF(NFACMX),PBCNST(NFACMX),PBCHAR(NFACMX)
      DOUBLE PRECISION DBCSET,TBCSET
      DOUBLE PRECISION UBCSET,UBCMAX,UBCFRQ,UBCPHA
      INTEGER NBCCEL(NBCMAX),NBCFAC(NBCMAX)
      INTEGER NGBPRM(NBCPRI,NFACMX)
      INTEGER NBCVAL
      COMMON/NSBCCP/BCOORD,RGBPRM,
     +              YBCSET,
     +              PBCINF,PBCNST,PBCHAR,
     +              DBCSET,TBCSET,
     +              UBCSET,UBCMAX,UBCFRQ,UBCPHA,
     +              NBCCEL,NBCFAC,NGBPRM,NGLOBC,NBCVAL

C     OUTFLOW BC STORAGE SIZE PARAMETER
      INTEGER NBCPMX
      PARAMETER(NBCPMX = 1000)

C     TURBULENT INLET BC STORAGE SIZE PARAMETER
      INTEGER NBCSMX,NKINMX,NCINMX
      PARAMETER(NBCSMX = 1000, NKINMX = 50, NCINMX = 50)

C     TURBULENT INLET BC DATA
      DOUBLE PRECISION UBCSTO(NCMPMX,NBCSMX)
      DOUBLE PRECISION BINPRE(NCMPMX,NKINMX),BINMRE(NCMPMX,NKINMX)
      DOUBLE PRECISION BINPIM(NCMPMX,NKINMX),BINMIM(NCMPMX,NKINMX)
      DOUBLE PRECISION USUMRE(NCMPMX,NKINMX),UDIFRE(NCMPMX,NKINMX)
      DOUBLE PRECISION USUMIM(NCMPMX,NKINMX),UDIFIM(NCMPMX,NKINMX)
      DOUBLE PRECISION SCOS(NKINMX,NCINMX),SSIN(NKINMX,NCINMX)
      DOUBLE PRECISION UBCAVE(NCMPMX),UBCVAR(NCMPMX)
      DOUBLE PRECISION TOVRNK
      DOUBLE PRECISION GSIGMA,TINCOR,OMTCOR
      INTEGER KMLIST(2,NKINMX)
      INTEGER NKLIST
      INTEGER IBSEED
      INTEGER NBCAVE
      LOGICAL FBCSTO(NBCSMX)
      LOGICAL FLNTRB

      COMMON/NSBTRB/UBCSTO,
     +              BINPRE,BINMRE,BINPIM,BINMIM,
     +              USUMRE,UDIFRE,USUMIM,UDIFIM,
     +              SCOS,SSIN,
     +              UBCAVE,UBCVAR,
     +              TOVRNK,
     +              GSIGMA,TINCOR,OMTCOR,
     +              KMLIST,NKLIST,
     +              IBSEED,
     +              NBCAVE,
     +              FBCSTO,
     +              FLNTRB

C     NSBCCP-------------------------------------------------------------------
C     ERHNDL-------------------------------------------------------------------

C     MAX NUMBER OF ROUTINE NAMES
      INTEGER NCRNMX
      PARAMETER(NCRNMX = 32)

C     MAX NUMBER OF ERROR DESCRIPTIONS
      INTEGER NCRDMX
      PARAMETER(NCRDMX = 50)

C     ERROR SEVERITY CODES
      INTEGER NMINOR,NWARNN,NSEVER,NFATAL
      PARAMETER(NMINOR = 1, NWARNN = 2, NSEVER = 3, NFATAL = 4)

C     ERROR COUNTER MAX VALUES
      INTEGER MMINOR,MWARNN,MSEVER
      PARAMETER(MMINOR = 100, MWARNN = 20, MSEVER = 5)

C     ERROR COUNTERS
      INTEGER JMINOR,JWARNN,JSEVER

C     CALLING ROUTINE NAMES
      CHARACTER*6 CRNAME(NCRNMX)

C     ERROR DESCRIPTIONS
      CHARACTER*40 CDEROR(NCRDMX)

      COMMON/ERHNDL/JMINOR,JWARNN,JSEVER,CRNAME,CDEROR

C     ERHNDL-------------------------------------------------------------------
