      SUBROUTINE CPMVAL(TLOCAL,YLOCAL,CPLOCL,RGLOCL)

C     *************************************************************************
C
C     CPMVAL
C     ======
C
C     AUTHOR
C     ------
C     R.S.CANT  --  CAMBRIDGE UNIVERSITY ENGINEERING DEPARTMENT
C
C     CHANGE RECORD
C     -------------
C     12-MAR-2008:  CREATED
C     27-JAN-2011:  RSC UPDATED TO DO ALL SPECIES AT ONCE
C     13-NOV-2016:  RSC UPDATED TO DO MIXTURE CP AND GAS CONSTANT
C
C     DESCRIPTION
C     -----------
C     DNS CODE HAMISH
C     COMPUTES MIXTURE SPECIFIC HEAT CAPACITY
C     AND MIXTURE GAS CONSTANT
C
C     *************************************************************************


C     GLOBAL DATA
C     ===========
C     -------------------------------------------------------------------------
      INCLUDE 'com_hamish.h'
C     -------------------------------------------------------------------------


C     ARGUMENTS
C     =========
      DOUBLE PRECISION YLOCAL(NSPCMX)
      DOUBLE PRECISION TLOCAL,CPLOCL,RGLOCL


C     LOCAL DATA
C     ==========
      DOUBLE PRECISION FORNOW
      INTEGER ISPEC,ITINT,ICP


C     =========================================================================

C     BEGIN
C     =====

C     RUN THROUGH ALL SPECIES
      CPLOCL = ZERO
      RGLOCL = ZERO
      ITINT = 1
      DO ISPEC = 1, NSPEC

        FORNOW = AMASCP(NCPOLY(ITINT,ISPEC),ITINT,ISPEC)
        DO ICP = NCPOM1(ITINT,ISPEC),1,-1
          FORNOW = AMASCP(ICP,ITINT,ISPEC) + FORNOW*TLOCAL
        ENDDO
        CPLOCL = CPLOCL + YLOCAL(ISPEC)*FORNOW
        RGLOCL = RGLOCL + YLOCAL(ISPEC)*RGSPEC(ISPEC)

      ENDDO
C     RUN THROUGH ALL SPECIES

C     =========================================================================


      RETURN
      END
