      SUBROUTINE DEREFN
 
C     *************************************************************************
C
C     DEREFN
C     ======
C
C     AUTHOR
C     ------
C     R.S.CANT  --  CAMBRIDGE UNIVERSITY ENGINEERING DEPARTMENT
C
C     CHANGE RECORD
C     -------------
C     16-NOV-2008:  CREATED
C
C     DESCRIPTION
C     -----------
C     DNS CODE HAMISH
C     DEREFINES THE SPATIAL MESH
C
C     *************************************************************************


C     GLOBAL DATA
C     ===========
C     -------------------------------------------------------------------------
      INCLUDE 'com_hamish.h'
C     -------------------------------------------------------------------------


C     LOCAL DATA
C     ==========
      INTEGER NTDREF(NINDMX,NRDMAX)
      INTEGER NTDLOC(NINDMX,NOCSMX)
      INTEGER NINDPR(NRDMAX)
      INTEGER MCRUN(NINDMX),MCMOV(NINDMX)
      INTEGER MMOCTS(NIOCMX),MMLOCT(NIOCMX)
      INTEGER NCELOC(NOCSMX)
      INTEGER JCELL,JFACE,ICPREF,ICPLOC,ICLOCL,ICDREF,NCDREF
      INTEGER ICBASE,IOFSET,JOFSET
      INTEGER ISCODE,IFCODE
      INTEGER ILEVEL,MLEVEL,MLVCHK,MLVPAR,MOCPAR
      LOGICAL FLNOCT

C     DIAGNOSTICS
      INTEGER LPROC

C     BEGIN
C     =====

C     DIAGNOSTICS
      LPROC = 20

C     DIAGNOSTICS
      IF(IPROC.EQ.LPROC)THEN
        WRITE(6,*)'In DEREFN',ITIME,NCELL
      ENDIF

C     DIAGNOSTICS
      IF(IPROC.EQ.LPROC)THEN
        WRITE(6,'(2I6)')N2DREF
        DO ICDREF = 1,N2DREF
          WRITE(6,'(2I6)')ICDREF,NINDDR(ICDREF)
        ENDDO
      ENDIF

C     =========================================================================

C     CURRENT DEREFINEMENT LIST IS PROVISIONAL
C     ----------------------------------------
      ICPREF = 0

C     CHECK CELL FACE STATUS
      DO ICDREF = 1, N2DREF
        JCELL = NINDDR(ICDREF)

C       DIAGNOSTICS
        IF(IPROC.EQ.LPROC)WRITE(6,'(2I6)')ICDREF,NINDDR(ICDREF)

        JFACE = 1
        ISCODE = NSCODE(JCELL)
        FLNOCT =  .TRUE.
3000    CONTINUE
          IFCODE = MOD(ISCODE,NSBASE)
          IF(IFCODE.EQ.N2HTOH)THEN
C           NEXT-DOOR CELL IS MORE REFINED - NO DEREFINEMENT
            FLNOCT = .FALSE.
          ELSE
            IF(JFACE.LT.NFACE)THEN
              JFACE = JFACE + 1
              ISCODE = ISCODE/NSBASE
              GOTO 3000
            ENDIF
          ENDIF
C       END OF LOOP 3000
        IF(FLNOCT)THEN
          ICPREF = ICPREF + 1
          NINDPR(ICPREF) = NINDDR(ICDREF)
        ENDIF
      ENDDO
      NCDREF = ICPREF
      N2DREF = NCDREF
      DO ICDREF = 1, N2DREF
        NINDDR(ICDREF) = NINDPR(ICDREF)

C       DIAGNOSTICS
        IF(IPROC.EQ.LPROC)WRITE(6,'(2I6)')ICDREF,NINDDR(ICDREF)

      ENDDO


C     LOOP OVER PROVISIONAL DEREFINEMENT LIST
C     ---------------------------------------
      ICPREF = 0
      ICDREF = 0

1000  CONTINUE

C       NEXT ENTRY
        ICPREF = ICPREF + 1

C       RETRIEVE THE CORRESPONDING M-CODE
        JCELL = NINDDR(ICPREF)
        CALL MCRTRV(MCRUN,NMCODE,NSIZMX,JCELL)

C       EXTRACT ITS LEVEL AND OCTAL VALUES
        CALL MCGLVL(MCRUN,MLEVEL)
        CALL MCCI2O(MCRUN,MMOCTS)

C       DIAGNOSTICS
        IF(IPROC.EQ.LPROC)THEN
          WRITE(6,'(15I5)')ICPREF,JCELL,MLEVEL,
     +        (MMOCTS(ILEVEL),ILEVEL=1,MLEVEL)
        ENDIF

C       CHECK HIGHEST OCTAL VALUE
        IF(MMOCTS(MLEVEL).EQ.0)THEN

C         POSSIBLE FIRST MEMBER OF A NEW OCTANT
          ICBASE = ICPREF
          MLVCHK = MLEVEL
          MLVPAR = MLEVEL - 1
          MOCPAR = MMOCTS(MLVPAR)

C         DIAGNOSTICS
          IF(IPROC.EQ.LPROC)THEN
            IOFSET = 0
            ICLOCL = 1
            WRITE(6,'(2X,15I5)')ICBASE,IOFSET,ICLOCL,ICBASE,JCELL,
     +                         MLEVEL,
     +                        (MMOCTS(ILEVEL),ILEVEL=1,MLEVEL)
          ENDIF

C         MAKE A LOCAL COPY OF THE M-CODE AND THE CELL NUMBER
          ICLOCL = 1
          CALL MCSTOR(MCRUN,NTDLOC,NOCSMX,ICLOCL)
          NCELOC(ICLOCL) = JCELL

C         START A NEW SEARCH
          IOFSET = 0
2000      CONTINUE

C           NEXT ENTRY
            IOFSET = IOFSET + 1
            ICPLOC = ICBASE + IOFSET

C           CHECK FOR END OF PROVISIONAL DEREFINEMENT LIST
            IF(ICPLOC.LE.N2DREF)THEN

C             RETRIEVE THE CORRESPONDING M-CODE
              JCELL = NINDDR(ICPLOC)
              CALL MCRTRV(MCRUN,NMCODE,NSIZMX,JCELL)

C             EXTRACT ITS LEVEL AND OCTAL VALUES
              CALL MCGLVL(MCRUN,MLEVEL)
              CALL MCCI2O(MCRUN,MMLOCT)

CC             DIAGNOSTICS
C              IF(IPROC.EQ.LPROC)THEN
C                WRITE(6,'(2X,15I5)')ICBASE,IOFSET,ICLOCL,ICPLOC,JCELL,
C     +                             MLEVEL,
C     +                            (MMLOCT(ILEVEL),ILEVEL=1,MLEVEL)
C              ENDIF

C             CHECK LEVEL
              FLNOCT = (MLEVEL.EQ.MLVCHK)
C             CHECK OCTET INDEX
              FLNOCT = FLNOCT.AND.(MMLOCT(MLEVEL).EQ.IOFSET)
C             CHECK ANCESTRY
              DO ILEVEL = 1, MLVPAR
                FLNOCT = FLNOCT.AND.(MMLOCT(ILEVEL).EQ.MMOCTS(ILEVEL))
              ENDDO

C             CHECK FOR NEXT MEMBER OF THE OCTANT
              IF(FLNOCT)THEN

C               NEXT MEMBER HAS BEEN FOUND
C               --------------------------

C               MAKE A LOCAL COPY OF THE M-CODE AND THE CELL NUMBER
                ICLOCL = ICLOCL + 1
                CALL MCSTOR(MCRUN,NTDLOC,NOCSMX,ICLOCL)
                NCELOC(ICLOCL) = JCELL

CC               DIAGNOSTICS
C                IF(IPROC.EQ.LPROC)THEN
C                  WRITE(6,*)'next',FLNOCT,ICLOCL,JCELL
C                ENDIF

C               CHECK HOW MANY HAVE NOW BEEN FOUND
                IF(IOFSET.LT.NOFSET)THEN

C                 STILL NEED MORE
                  GOTO 2000

                ELSE

C                 COMPLETE OCTANT HAS BEEN FOUND
C                 ------------------------------

CC                 DIAGNOSTICS
C                  IF(IPROC.EQ.LPROC)THEN
C                    WRITE(6,*)'complete',FLNOCT
C                  ENDIF

C                 TRANSFER THE M-CODES AND THE CORRESPONDING CELL NUMBERS
                  DO JOFSET = 0,NOFSET

                    ICLOCL =  1 + JOFSET
                    CALL MCRTRV(MCMOV,NTDLOC,NOCSMX,ICLOCL)
                    JCELL = NCELOC(ICLOCL)

                    ICDREF = ICDREF + 1
                    CALL MCSTOR(MCMOV,NTDREF,NRDMAX,ICDREF)
                    NINDPR(ICDREF) = JCELL

                  ENDDO

C                 UPDATE INDEX FOR PROVISIONAL DEREFINEMENT LIST
                  ICPREF = ICPREF + NOFSET

                ENDIF
C               END OF CHECK HOW MANY HAVE NOW BEEN FOUND

              ELSE

C               NEXT MEMBER HAS NOT BEEN FOUND
C               ------------------------------
                CONTINUE
  
              ENDIF
C             END OF CHECK FOR NEXT MEMBER

            ENDIF
C           CHECK FOR END OF PROVISIONAL DEREFINEMENT LIST

C         END OF LOOP 2000 OVER LOCAL SEARCH

        ELSE

C         NOT THE FIRST MEMBER OF A NEW OCTANT
C         ------------------------------------
          CONTINUE

        ENDIF
C       END OF CHECK HIGHEST OCTAL VALUE

C       CHECK FOR END OF PROVISIONAL DEREFINEMENT LIST
        IF(ICPREF.LT.N2DREF)GOTO 1000

C     END OF LOOP 1000 OVER DEREFINEMENT LIST

C     MAX NO OF OCTANTS ACTUALLY TO DEREFINE
      NCDREF = ICDREF
      N2DREF = NCDREF

C     DIAGNOSTICS
      IF(IPROC.EQ.LPROC)THEN
        WRITE(6,'(2I6)')N2DREF
        DO ICDREF = 1,N2DREF
          JCELL = NINDPR(ICDREF)
          WRITE(6,'(4I6)')ICDREF,JCELL,NLEVEL(JCELL),NRSTAT(JCELL)
        ENDDO
      ENDIF

C     =========================================================================

      IF(NCDREF.GT.0)THEN

C       =======================================================================

C       CARRY OUT THE DEREFINEMENT ACTIONS
C       ----------------------------------
        CALL DRFACT(NTDREF,NINDPR,NCDREF)

C       GARBAGE COLLECTION FOLLOWING DEREFINEMENT
C       ------------------
        CALL DRFGRC

C       =======================================================================

      ENDIF

C     =========================================================================


      RETURN
      END
