      SUBROUTINE DSHIFT(NDCELL,NTOMOV,NEND)
 
C     *************************************************************************
C
C     DSHIFT
C     ======
C
C     AUTHOR
C     ------
C     R.S.CANT  --  CAMBRIDGE UNIVERSITY ENGINEERING DEPARTMENT
C
C     CHANGE RECORD
C     -------------
C     11-APR-2009:  CREATED
C
C     DESCRIPTION
C     -----------
C     DNS CODE HAMISH
C     PARALLEL LOAD-BALANCING
C     SHIFTS PHYSICAL DATA
C
C     *************************************************************************


C     GLOBAL DATA
C     ===========
C     -------------------------------------------------------------------------
      INCLUDE 'com_hamish.h'
C     -------------------------------------------------------------------------


C     ARGUMENTS
C     =========
      INTEGER NDCELL,NTOMOV,NEND


C     LOCAL DATA
C     ==========
      INTEGER JCELL,JDEST,JSPEC


C     BEGIN
C     =====

C     =========================================================================

      IF(NEND.LT.0)THEN

C       =======================================================================

C       SHIFT DATA LEFT
        DO JCELL = NTOMOV+1, NDCELL
          JDEST = JCELL - NTOMOV
          DRUN(JDEST) = DRUN(JCELL)
          URUN(1,JDEST) = URUN(1,JCELL)
          URUN(2,JDEST) = URUN(2,JCELL)
          URUN(3,JDEST) = URUN(3,JCELL)
          ERUN(JDEST) = ERUN(JCELL)
          DO JSPEC = 1, NSPEC
            YRUN(JSPEC,JDEST) = YRUN(JSPEC,JCELL)
          ENDDO
        ENDDO

C       =======================================================================

      ELSE

C       =======================================================================

C       SHIFT DATA RIGHT
        DO JCELL = NDCELL, 1, -1
          JDEST = JCELL + NTOMOV
          DRUN(JDEST) = DRUN(JCELL)
          URUN(1,JDEST) = URUN(1,JCELL)
          URUN(2,JDEST) = URUN(2,JCELL)
          URUN(3,JDEST) = URUN(3,JCELL)
          ERUN(JDEST) = ERUN(JCELL)
          DO JSPEC = 1, NSPEC
            YRUN(JSPEC,JDEST) = YRUN(JSPEC,JCELL)
          ENDDO
        ENDDO

C       =======================================================================

      ENDIF

C     =========================================================================

      RETURN
      END
