      SUBROUTINE FLAMIN 
 
C     *************************************************************************
C
C     FLAMIN
C     ======
C
C     AUTHOR
C     ------
C     R.S.CANT  --  CAMBRIDGE UNIVERSITY ENGINEERING DEPARTMENT
C
C     CHANGE RECORD
C     -------------
C     28-DEC-2003:  CREATED FOR SENGA2
C     31-JUL-2010:  ADOPTED FOR HAMISH
C 
C     DESCRIPTION
C     -----------
C     SETS INITIAL THERMOCHEMICAL FIELD
C     2D GAUSSIAN HOTSPOT
C     
C     *************************************************************************


C     GLOBAL DATA
C     ===========
C     -------------------------------------------------------------------------
      INCLUDE 'com_hamish.h'
C     -------------------------------------------------------------------------


C     PARAMETERS
C     ==========
C     PRESSURE PULSE AMPLITUDE
      DOUBLE PRECISION TRPEAK
      PARAMETER(TRPEAK = 1.0D-3)

C     PRESSURE PULSE LOCATION AND THICKNESS
      DOUBLE PRECISION XLOCAT,XTHICK,YLOCAT,YTHICK,ZLOCAT,ZTHICK
      PARAMETER(XLOCAT = 8.0D-4, XTHICK = 5.0D-4)
      PARAMETER(YLOCAT = 8.0D-4, YTHICK = 5.0D-4)
      PARAMETER(ZLOCAT = 8.0D-4, ZTHICK = 5.0D-4)


C     LOCAL DATA
C     ==========
      DOUBLE PRECISION XCOORD,YCOORD,ZCOORD,ARGMNT,FORNOW
      INTEGER MCRUN(NINDMX)
      INTEGER MLEVEL,MX,MY,MZ
      INTEGER JCELL
      INTEGER LPROC


C     BEGIN
C     =====

C     DIAGNOSTICS
      LPROC = 0

C     =========================================================================

C     SPECIFY INITIAL THERMOCHEMICAL FIELD HERE
C     =========================================


C     SET PRESSURE PROFILE
C     --------------------
      DO JCELL = 1, NCELL

C       LOCAL CELL-CENTRE COORDINATES
        CALL MCRTRV(MCRUN,NMCODE,NSIZMX,JCELL)
        MLEVEL = NLEVEL(JCELL)
        CALL MCCXYZ(MCRUN,MLEVEL,MX,MY,MZ)
        XCOORD = (REAL(MX) + HALF)*HCSIZE(MLEVEL)
        YCOORD = (REAL(MY) + HALF)*HCSIZE(MLEVEL)
        ZCOORD = (REAL(MZ) + HALF)*HCSIZE(MLEVEL)

C       GAUSSIAN FOR TEMPERATURE
        ARGMNT = ZERO
        FORNOW = (XCOORD-XLOCAT)/XTHICK
        ARGMNT = ARGMNT + FORNOW*FORNOW
        FORNOW = (YCOORD-YLOCAT)/YTHICK
        ARGMNT = ARGMNT + FORNOW*FORNOW
C        FORNOW = (ZCOORD-ZLOCAT)/ZTHICK
C        ARGMNT = ARGMNT + FORNOW*FORNOW
C        TRUN(JCELL) = TRIN + TRPEAK*EXP(-ARGMNT)
        YRUN(1,JCELL) = YRIN(1) - TRPEAK*EXP(-ARGMNT)
        YRUN(2,JCELL) = YRIN(2) + TRPEAK*EXP(-ARGMNT)

      ENDDO

C     =========================================================================


      RETURN
      END
