      SUBROUTINE MCCO2I(MCODE,MLOCL)
 
C     *************************************************************************
C
C     MCCO2I
C     ======
C
C     AUTHOR
C     ------
C     R.S.CANT  --  CAMBRIDGE UNIVERSITY ENGINEERING DEPARTMENT
C
C     CHANGE RECORD
C     -------------
C     25-JUN-2008:  CREATED
C     08-MAY-2011:  REFORMULATED FOR IMPROVED PERFORMANCE
C
C     DESCRIPTION
C     -----------
C     DNS CODE HAMISH
C     MORTON CODE MANIPULATION
C     CONVERTS AN OCTAL STRING TO AN ENCODED INTEGER ARRAY
C     NOTE: LEVEL CODE MUST BE SET SEPARATELY
C
C     *************************************************************************


C     GLOBAL DATA
C     ===========
C     -------------------------------------------------------------------------
      INCLUDE 'com_mcmlib.h'
C     -------------------------------------------------------------------------


C     ARGUMENTS
C     =========
      INTEGER MCODE(MCSIZE)
      INTEGER MLOCL(MCOCTS)


C     LOCAL DATA
C     ==========
      INTEGER ICSIZE,ICOCTS,IPOCTS


C     BEGIN
C     =====

C     =========================================================================

C     INITIALISE
C     ----------
      DO ICSIZE = 1, MCSIZE
        MCODE(ICSIZE) = 0
      ENDDO

C     =========================================================================

C     CONVERT OCTAL STRING TO MORTON CODE
C     -----------------------------------
      ICOCTS = 0
      DO ICSIZE = 1, MCSIZE
        DO IPOCTS = 0, NIOCTS(ICSIZE)-1
          ICOCTS = ICOCTS + 1
          MCODE(ICSIZE) = MCODE(ICSIZE) + MLOCL(ICOCTS)*KCPWR8(IPOCTS)
        ENDDO
      ENDDO

C     =========================================================================


      RETURN
      END
