      SUBROUTINE MCINIT
 
C     *************************************************************************
C
C     MCINIT
C     ======
C
C     AUTHOR
C     ------
C     R.S.CANT  --  CAMBRIDGE UNIVERSITY ENGINEERING DEPARTMENT
C
C     CHANGE RECORD
C     -------------
C     25-JUN-2008:  CREATED
C     08-MAY-2011:  REFORMULATED FOR IMPROVED PERFORMANCE
C
C     DESCRIPTION
C     -----------
C     DNS CODE HAMISH
C     MORTON CODE MANIPULATION
C     INITIALISES THE MORTON CODE DATA
C
C     *************************************************************************


C     GLOBAL DATA
C     ===========
C     -------------------------------------------------------------------------
      INCLUDE 'com_mcmlib.h'
C     -------------------------------------------------------------------------

C     LOCAL DATA
C     ==========
      INTEGER ICSIZE,ICBITS,ICOCTS


C     BEGIN
C     =====

C     =========================================================================

C     INITIALISE POWERS OF TWO
C     ------------------------
      KCPWR2(0) = 1
      DO ICBITS = 1,NLBITS
        KCPWR2(ICBITS) = KCPWR2(ICBITS-1)*2
      ENDDO

C     INITIALISE POWERS OF EIGHT
C     --------------------------
      KCPWR8(0) = 1
      DO ICOCTS = 1,NLOCTS
        KCPWR8(ICOCTS) = KCPWR8(ICOCTS-1)*8
      ENDDO

C     =========================================================================

C     INITIALISE BITS PER INTEGER
C     ---------------------------
      DO ICSIZE = 1, MCSIZE
        NIBITS(ICSIZE) = NLBITS
      ENDDO
      NIBITS(MCSIZE) = NHBITS

C     INITIALISE OCTETS PER INTEGER
C     -----------------------------
      DO ICSIZE = 1, MCSIZE
        NIOCTS(ICSIZE) = NLOCTS
      ENDDO
      NIOCTS(MCSIZE) = NHOCTS

C     =========================================================================

C     INITIALISE BIT LIMITS
C     ---------------------
      NMBITS = (MCSIZE-1)*NLBITS + NHBITS
      NCBITS = NMBITS + NLVBTS
      NLGBLO = (MCSIZE-1)*NLBITS + NLVBLO - 1

C     INITIALISE OCTET LIMITS
C     -----------------------
      NMOCTS = (MCSIZE-1)*NLOCTS + NHOCTS
      NCOCTS = NMOCTS + NLVOCS
      NLGOLO = (MCSIZE-1)*NLOCTS + NLVOLO - 1

C     =========================================================================


      RETURN
      END
