      SUBROUTINE PARTRE(NTRMOT,NTRLVL,NRMCEL,NTREFN,NTRCEL,
     +                  NCREFN,NGREFN)
 
C     *************************************************************************
C
C     PARTRE
C     ======
C
C     AUTHOR
C     ------
C     R.S.CANT  --  CAMBRIDGE UNIVERSITY ENGINEERING DEPARTMENT
C
C     CHANGE RECORD
C     -------------
C     31-DEC-2008:  CREATED
C
C     DESCRIPTION
C     -----------
C     DNS CODE HAMISH
C     EXCHANGES TREE DATA BETWEEN PROCESSORS
C
C     *************************************************************************


C     GLOBAL DATA
C     ===========
C     -------------------------------------------------------------------------
      INCLUDE 'com_hamish.h'
C     -------------------------------------------------------------------------


C     ARGUMENTS
C     =========
      INTEGER NTRMOT(NINDMX,NREMAX)
      INTEGER NTREFN(NINDMX,NRDMAX)
      INTEGER NTRLVL(NREMAX)
      INTEGER NTRCEL(NRDMAX)
      INTEGER NRMCEL,NCREFN,NGREFN


C     LOCAL DATA
C     ==========
      INTEGER NRRMOT(NREMAX),NRRLVL(NREMAX)
      INTEGER MCRUN(NINDMX),MCNXT(NINDMX)
      INTEGER NMSEND(NPROMX),NMRECV(NPROMX)
      INTEGER NDSEND(NPROMX),NDRECV(NPROMX)
      INTEGER KCELL,INCODE,IRCELL,ICREFN
      INTEGER JLEVEL,KLEVEL,LEVDIF
      INTEGER JPROC,JPROP1,NMCOMP
      CHARACTER*1 CFOUND


C     BEGIN
C     =====

C     =========================================================================

C     PARTITION THE LIST OF REMOTE CELLS
C     USING THE PARTITION INTERVAL TABLE
      DO JPROP1 = 1, NPROC
        N2SEND(JPROP1) = 0
        N2RECV(JPROP1) = 0
      ENDDO

      JPROC = 0
      JPROP1 = 1
      CALL MCRTBL(MCNXT,NTABLE,NPROMX,JPROC)
      CALL MCGLVL(MCNXT,KLEVEL)

      DO IRCELL = 1,NRMCEL

        CALL MCRTRV(MCRUN,NTRMOT,NREMAX,IRCELL)
1000    CONTINUE
          CALL MCCOML(MCRUN,MCNXT,KLEVEL,NMCOMP)
          IF(NMCOMP.GT.0)THEN
            JPROC = JPROP1
            JPROP1 = JPROP1 + 1
            CALL MCRTBL(MCNXT,NTABLE,NPROMX,JPROC)
            CALL MCGLVL(MCNXT,KLEVEL)
            GOTO 1000
          ENDIF
C       END OF LOOP 1000
        N2SEND(JPROP1) = N2SEND(JPROP1) + 1

      ENDDO

C     -------------------------------------------------------------------------

C     EXCHANGE NUMBERS OF CELLS
      CALL P_ATOI(N2SEND,NPROMX,1,N2RECV,NPROMX,1)

C     TOTAL NUMBER OF CELLS TO RECEIVE
      NRRCEL = 0
      DO JPROP1 = 1,NPROC
        NRRCEL = NRRCEL + N2RECV(JPROP1)
      ENDDO

C     -------------------------------------------------------------------------

C     SET UP EXCHANGE OF M-CODES
      NMSEND(1) = 2*N2SEND(1)
      NMRECV(1) = 2*N2RECV(1)
      NCSEND(1) = 0
      NCRECV(1) = 0
      NDSEND(1) = 0
      NDRECV(1) = 0
      DO JPROP1 = 2,NPROC
        JPROC = JPROP1 - 1
        NMSEND(JPROP1) = 2*N2SEND(JPROP1)
        NMRECV(JPROP1) = 2*N2RECV(JPROP1)
        NCSEND(JPROP1) = NCSEND(JPROC) + N2SEND(JPROC)
        NCRECV(JPROP1) = NCRECV(JPROC) + N2RECV(JPROC)
        NDSEND(JPROP1) = NDSEND(JPROC) + NMSEND(JPROC)
        NDRECV(JPROP1) = NDRECV(JPROC) + NMRECV(JPROC)
      ENDDO

C     -------------------------------------------------------------------------

C     EXCHANGE M-CODES
      CALL P_A2IV(NTRMOT,NREMAX,NMSEND,NDSEND,
     +            NRRMOT,NREMAX,NMRECV,NDRECV,NPROC)

C     -------------------------------------------------------------------------

C     EXCHANGE LEVELS
      CALL P_A2IV(NTRLVL,NREMAX,N2SEND,NCSEND,
     +            NRRLVL,NREMAX,N2RECV,NCRECV,NPROC)

C     -------------------------------------------------------------------------

C     INITIALISE REFINEMENT COUNTER
      ICREFN = NCREFN

C     RUN THROUGH ALL RECEIVED M-CODES
      DO INCODE = 1,NRRCEL

C       FETCH THE M-CODE
        CALL MCRTRV(MCNXT,NRRMOT,NREMAX,INCODE)

C       FETCH THE LEVEL FOR COMPARISON
        JLEVEL = NRRLVL(INCODE)

C       SEARCH FOR THE CORRESPONDING CELL
        CALL OCFIND(NOCHLD,COCODE,NOCTMX,MCNXT,KLEVEL,KCELL,CFOUND)

C       CHECK FINDINGS
        IF(CFOUND.EQ.CHTWIG)THEN

C         --------------------------------------------------------------------- 

C         CELL IS LOCAL
C         -------------

C         CHECK DIFFERENCE OF LEVEL
          LEVDIF = JLEVEL - KLEVEL
          IF(LEVDIF.GT.0)THEN

C           NEIGHBOUR IS MORE THAN ONE LEVEL LESS REFINED
C           MARK NEIGHBOUR FOR REFINEMENT
            ICREFN = ICREFN + 1
            CALL MCTLVL(MCNXT,KLEVEL)
            CALL MCSTOR(MCNXT,NTREFN,NRDMAX,ICREFN)
            NTRCEL(ICREFN) = KCELL

          ENDIF

C         --------------------------------------------------------------------- 

        ELSEIF(CFOUND.EQ.CHNRML)THEN

C         --------------------------------------------------------------------- 

C         NEIGHBOUR IS NOT FOUND
C         ----------------------
C         AT LEVEL OF LOCAL CELL OR LOWER

C         2h-h(-) TRANSITION
C         ASSUME NEIGHBOUR IS MORE REFINED - TAKE NO ACTION
          CONTINUE

C         --------------------------------------------------------------------- 

        ELSE

C         --------------------------------------------------------------------- 

C         ERROR CONDITION - received cell not found
          CALL ERHAND(6,13,4)

C         --------------------------------------------------------------------- 

        ENDIF
C       END OF CHECK FINDINGS

C       ----------------------------------------------------------------------- 

      ENDDO
C     END OF RUN THROUGH RECEIVED M-CODES

C     =========================================================================

C     TOTAL NUMBER OF CELLS TO REFINE
      NCREFN = ICREFN

C     CHECK MAX NUMBER OF CELLS STILL TO REFINE ON ANY PROCESSOR
      CALL P_GMXI(NCREFN,NGREFN)

C     =========================================================================


      RETURN
      END
