      SUBROUTINE TRANCO(TLOCAL,CPLOCL,VSLOCL,TCLOCL,DMLOCL)
 
C     *************************************************************************
C
C     TRANCO
C     ======
C
C     AUTHOR
C     ------
C     R.S.CANT  --  CAMBRIDGE UNIVERSITY ENGINEERING DEPARTMENT
C
C     CHANGE RECORD
C     -------------
C     28-SEP-2014:  CREATED
C     
C     DESCRIPTION
C     -----------
C     DNS CODE HAMISH
C     COMPUTES LOCAL VISCOSITY, THERMAL CONDUCTIVITY AND MASS DIFFUSIVITY
C
C     *************************************************************************


C     GLOBAL DATA
C     ===========
C     -------------------------------------------------------------------------
      INCLUDE 'com_hamish.h'
C     -------------------------------------------------------------------------


C     ARGUMENTS
C     =========
      DOUBLE PRECISION DMLOCL(NSPCMX)
      DOUBLE PRECISION TLOCAL,CPLOCL,VSLOCL,TCLOCL


C     LOCAL DATA
C     ==========
      DOUBLE PRECISION THCOCP
      INTEGER JSPEC


C     BEGIN
C     =====

C     =========================================================================

C     EVALUATE MIXTURE VISCOSITY, THERMAL CONDUCTIVITY AND MASS DIFFUSIVITY
      THCOCP = ALAMDA*EXP(RLAMDA*LOG(TLOCAL))
      VSLOCL = THCOCP*PRANTL
      TCLOCL = THCOCP*CPLOCL
      DO JSPEC = 1, NSPEC
        DMLOCL(JSPEC) = THCOCP*OLEWIS(JSPEC)
      ENDDO

C     =========================================================================


      RETURN
      END
