      SUBROUTINE LHTREE(NHCODE,NHLSIZ,NHCELL,
     +                  NHCPAR,NHCHLD,CHCODE,NHCTMX,NHCHWM)

C     *************************************************************************
C
C     LHTREE
C     ======
C
C     AUTHOR
C     ------
C     R.S.CANT  --  CAMBRIDGE UNIVERSITY ENGINEERING DEPARTMENT
C
C     CHANGE RECORD
C     -------------
C     18-MAR-2016:  CREATED
C
C     DESCRIPTION
C     -----------
C     DNS CODE HAMISH
C     MAKES A LOCAL OCTREE ON A SET OF SORTED (ASCENDING) M-CODES
C
C     *************************************************************************


C     GLOBAL DATA
C     ===========
C     -------------------------------------------------------------------------
      INCLUDE 'com_hamish.h'
C     -------------------------------------------------------------------------


C     PARAMETERS
C     ==========


C     ARGUMENTS
C     =========
      INTEGER NHCODE(NINDMX,NHLSIZ)
      INTEGER NHCHLD(0:7,NHCTMX)
      INTEGER NHCPAR(NHCTMX)
      INTEGER NHLSIZ,NHCELL,NHCTMX,NHCHWM
      CHARACTER*1 CHCODE(0:7,NOCTMX)


C     LOCAL DATA
C     ==========
      INTEGER MCRUN(NINDMX)
      INTEGER JHCELL,KHCELL,KLEVEL,MLEVEL
      CHARACTER*1 CFOUND

C     DIAGNOSTICS
      INTEGER LPROC


C     BEGIN
C     =====

C     DIAGNOSTICS
      LPROC = 0

CC     DIAGNOSTICS
C      IF(IPROC.EQ.LPROC)WRITE(6,*)'In LHTREE'

C     =========================================================================

C     (RE)INITIALISE THE OCTREE
      CALL OCREIN(NHCPAR,NHCHLD,CHCODE,NHCTMX,NHCHWM)

C     RUN THROUGH THE ACTUAL LAYER-HALO M-CODE LIST
      DO JHCELL = 1, NHCELL

C       FETCH THE M-CODE
        CALL MCRTRV(MCRUN,NHCODE,NHLSIZ,JHCELL)

C       FIND THE REQUIRED LEVEL
        CALL MCGLVL(MCRUN,MLEVEL)

C       LOOP OVER LEVELS
1000    CONTINUE

C         SEARCH FOR THIS M-CODE IN THE OCTREE
          CALL OCFIND(NHCHLD,CHCODE,NHCTMX,
     +                MCRUN,KLEVEL,KHCELL,CFOUND)

          IF(KLEVEL.LT.MLEVEL)THEN

C           M-CODE NOT FOUND - ADD A NEW LEVEL TO THE OCTREE AND TRY AGAIN
            CALL OCTADL(NHCPAR,NHCHLD,CHCODE,NHCTMX,NHCHWM,
     +                  MCRUN,KLEVEL,CHOUTC)

            GOTO 1000

          ELSE

C           M-CODE FOUND - SET ATTRIBUTE AND (TEMPORARY) CELL ID
            CALL OCTWIG(NHCHLD,CHCODE,NHCTMX,MCRUN,JHCELL,CFOUND)

CC           DIAGNOSTICS
C            IF(IPROC.EQ.LPROC)THEN
C              WRITE(6,'("LHTREE",2I5)')JHCELL
C              CALL MCRITE(MCRUN)
C            ENDIF

          ENDIF

C       END OF LOOP 1000 OVER LEVELS

      ENDDO
      
C     =========================================================================


      RETURN
      END
