      SUBROUTINE MCBINC(MCODE,MLOCL,NLEVEL,MDIRN,MSIGN)
 
C     *************************************************************************
C
C     MCBINC
C     ======
C
C     AUTHOR
C     ------
C     R.S.CANT  --  CAMBRIDGE UNIVERSITY ENGINEERING DEPARTMENT
C
C     CHANGE RECORD
C     -------------
C     22-MAY-2011:  CREATED
C
C     DESCRIPTION
C     -----------
C     DNS CODE HAMISH
C     MORTON CODE MANIPULATION
C     INCREMENTS XYZ COORDINATES USING A BIT STRING
C     AND CONVERTS THE BIT STRING INTO A MORTON CODE AT THE SPECIFIED LEVEL
C
C     *************************************************************************


C     GLOBAL DATA
C     ===========
C     -------------------------------------------------------------------------
      INCLUDE 'com_mcmlib.h'
C     -------------------------------------------------------------------------


C     ARGUMENTS
C     =========
      INTEGER MCODE(MCSIZE)
      INTEGER MLOCL(MCBITS)
      INTEGER NLEVEL,MDIRN,MSIGN


C     LOCAL DATA
C     ==========
      INTEGER MLINC(MCBITS)
      INTEGER NPBITS(MCSIZE)
      INTEGER NLEVX3,NLEVM1,MCSLVL,MCSLM1
      INTEGER ICSIZE,ICBITS,IPBITS


C     BEGIN
C     =====

C     =========================================================================

C     INITIALISE
C     ----------
      NLEVX3 = NLEVEL*3
      NLEVM1 = NLEVEL - 1
      MCSLM1 = NLEVM1/NLOCTS
      DO ICSIZE = 1, MCSLM1
        NPBITS(ICSIZE) = NLBITS
      ENDDO
      MCSLVL = MCSLM1 + 1
      NPBITS(MCSLVL) = NLEVX3 - 3*MCSLM1*NLOCTS

      DO IPBITS = 1, NLEVX3
        MLINC(IPBITS) = MLOCL(IPBITS)
      ENDDO

C     =========================================================================

C     ADD ONE TO OCTAL STRING
C     -----------------------
C     WITH CARRY OPERATION
      ICBITS = NLEVX3 + MDIRN - 3
      IF(MSIGN.GT.0)THEN

1000    CONTINUE
          MLINC(ICBITS) = MLINC(ICBITS) + 1
          IF(MLINC(ICBITS).GT.1)THEN
            MLINC(ICBITS) = 0
            ICBITS = ICBITS - 3
            IF(ICBITS.GE.1)GOTO 1000
          ENDIF
C       END OF LOOP 1000

      ELSE

2000    CONTINUE
          MLINC(ICBITS) = MLINC(ICBITS) - 1
          IF(MLINC(ICBITS).LT.0)THEN
            MLINC(ICBITS) = 1
            ICBITS = ICBITS - 3
            IF(ICBITS.GE.1)GOTO 2000
          ENDIF
C       END OF LOOP 2000

      ENDIF

C     =========================================================================

C     CONVERT BIT STRING TO MORTON CODE
C     ---------------------------------
C     INITIALISE
      DO ICSIZE = 1, MCSIZE
        MCODE(ICSIZE) = 0
      ENDDO

C     UP TO REQUIRED LEVEL ONLY
      ICBITS = 0
      DO ICSIZE = 1, MCSLVL
        DO IPBITS = 0, NPBITS(ICSIZE)-1
          ICBITS = ICBITS + 1
          MCODE(ICSIZE) = MCODE(ICSIZE) + MLINC(ICBITS)*KCPWR2(IPBITS)
        ENDDO
      ENDDO

C     =========================================================================

C     SET THE LEVEL CODE
      MCODE(MCSIZE) = MCODE(MCSIZE) + NLEVEL*KCPWR2(NLVBLO)

C     =========================================================================


      RETURN
      END
