      SUBROUTINE MCCOML(MCODE1,MCODE2,NLEVEL,NVALUE)
 
C     *************************************************************************
C
C     MCCOML
C     ======
C
C     AUTHOR
C     ------
C     R.S.CANT  --  CAMBRIDGE UNIVERSITY ENGINEERING DEPARTMENT
C
C     CHANGE RECORD
C     -------------
C     25-JUN-2008:  CREATED
C     15-MAY-2011:  REFORMULATED FOR IMPROVED PERFORMANCE
C
C     DESCRIPTION
C     -----------
C     DNS CODE HAMISH
C     MORTON CODE MANIPULATION
C     COMPARES TWO MORTON CODES TO THE SPECIFIED LEVEL
C
C     *************************************************************************


C     GLOBAL DATA
C     ===========
C     -------------------------------------------------------------------------
      INCLUDE 'com_mcmlib.h'
C     -------------------------------------------------------------------------


C     ARGUMENTS
C     =========
      INTEGER MCODE1(MCSIZE),MCODE2(MCSIZE)
      INTEGER NLEVEL,NVALUE


C     LOCAL DATA
C     ==========
      INTEGER MLOCL1(MCOCTS),MLOCL2(MCOCTS)
      INTEGER NPOCTS(MCSIZE)
      INTEGER MCRUN1,MCRUN2
      INTEGER NLEVM1,MCSLVL,MCSLM1
      INTEGER ICSIZE,ICOCTS,IPOCTS


C     BEGIN
C     =====

C     =========================================================================

C     INITIALISE
C     ----------
      NLEVM1 = NLEVEL - 1
      MCSLM1 = NLEVM1/NLOCTS
      DO ICSIZE = 1, MCSLM1
        NPOCTS(ICSIZE) = NLOCTS
      ENDDO
      MCSLVL = MCSLM1 + 1
      NPOCTS(MCSLVL) = NLEVEL - MCSLM1*NLOCTS

C     =========================================================================

C     CONVERT MORTON CODES TO OCTAL STRINGS
C     ------------------- -----------------
C     UP TO REQUIRED LEVEL ONLY
      ICOCTS = 0
      DO ICSIZE = 1, MCSLVL
        MCRUN1 = MCODE1(ICSIZE)
        MCRUN2 = MCODE2(ICSIZE)
        ICOCTS = ICOCTS + 1
        MLOCL1(ICOCTS) = MOD(MCRUN1,8)
        MLOCL2(ICOCTS) = MOD(MCRUN2,8)
        DO IPOCTS = 2, NPOCTS(ICSIZE)
          MCRUN1 = MCRUN1/8
          MCRUN2 = MCRUN2/8
          ICOCTS = ICOCTS + 1
          MLOCL1(ICOCTS) = MOD(MCRUN1,8)
          MLOCL2(ICOCTS) = MOD(MCRUN2,8)
        ENDDO
      ENDDO

C     =========================================================================

C     COMPARE THE OCTAL STRINGS
C     -------------------------
      ICOCTS = 1
      NVALUE = 0
1000  CONTINUE
        IF(MLOCL1(ICOCTS).GT.MLOCL2(ICOCTS))THEN
          NVALUE = 1
        ELSEIF(MLOCL1(ICOCTS).LT.MLOCL2(ICOCTS))THEN
          NVALUE = -1
        ELSE
          ICOCTS = ICOCTS + 1
          IF(ICOCTS.LE.NLEVEL)GOTO 1000
        ENDIF
C     END OF LOOP 1000

C     =========================================================================


      RETURN
      END
