      SUBROUTINE MCREAD(MCODE)
 
C     *************************************************************************
C
C     MCREAD
C     ======
C
C     AUTHOR
C     ------
C     R.S.CANT  --  CAMBRIDGE UNIVERSITY ENGINEERING DEPARTMENT
C
C     CHANGE RECORD
C     -------------
C     25-JUN-2008:  CREATED
C     11-MAY-2011;  REFORMULATED FOR IMPROVED PERFORMANCE
C
C     DESCRIPTION
C     -----------
C     DNS CODE HAMISH
C     MORTON CODE MANIPULATION
C     READS AN MCODE FROM STANDARD INPUT
C
C     *************************************************************************


C     GLOBAL DATA
C     ===========
C     -------------------------------------------------------------------------
      INCLUDE 'com_mcmlib.h'
C     -------------------------------------------------------------------------


C     ARGUMENTS
C     =========
      INTEGER MCODE(1:MCSIZE)


C     LOCAL DATA
C     ==========
      INTEGER MLOCL(0:MCBITS)
      INTEGER NLEVEL
      INTEGER ICOUNT,ICOCTS,IC
      INTEGER ICSIZE,ICBITS,IPBITS,IPOWER
      CHARACTER*79 CMCODE
      CHARACTER CDELIM
 

C     BEGIN
C     =====

C     =========================================================================

C     READ THE MORTON CODE INPUT FILE
C     -------------------------------
      READ(5,'(A)')CMCODE

C     CONVERT CHAR STRING TO MORTON CODE BIT STRING
      ICOUNT = 0
      ICBITS = -1

      DO ICOCTS = 1,NMOCTS
        DO IC = 1,3
          ICOUNT = ICOUNT + 1
          ICBITS = ICBITS + 1
          READ(CMCODE(ICOUNT:ICOUNT),'(I1)')MLOCL(ICBITS)
        ENDDO
        ICOUNT = ICOUNT + 1
        READ(CMCODE(ICOUNT:ICOUNT),'(A1)')CDELIM
      ENDDO
      DO IC = 1,NLVBTS
        ICOUNT = ICOUNT + 1
        ICBITS = ICBITS + 1
        READ(CMCODE(ICOUNT:ICOUNT),'(I1)')MLOCL(ICBITS)
      ENDDO

C     =========================================================================

C     CONVERT BIT STRING TO MORTON CODE
C     ---------------------------------
C     INITIALISE
      DO ICSIZE = 1,MCSIZE
        MCODE(ICSIZE) = 0
      ENDDO

C     UP TO REQUIRED LEVEL ONLY
      ICBITS = -1
      DO ICSIZE = 1, MCSIZE
        DO IPBITS = 1, NIBITS(ICSIZE)
          IPOWER = IPBITS - 1
          ICBITS = ICBITS + 1
          MCODE(ICSIZE) = MCODE(ICSIZE) + MLOCL(ICBITS)*KCPWR2(IPOWER)
        ENDDO
      ENDDO

C     =========================================================================

C     EXTRACT THE LEVEL
      NLEVEL = 0
      ICBITS = NLGBLO - 1
      DO IPBITS = 1,NLVBTS
        IPOWER = NLVBTS - IPBITS
        ICBITS = ICBITS + 1
        NLEVEL = NLEVEL + MLOCL(ICBITS)*KCPWR2(IPOWER)
      ENDDO

C     SET THE LEVEL CODE
      MCODE(MCSIZE) = MCODE(MCSIZE) + NLEVEL*KCPWR2(NLVBLO)

C     =========================================================================


      RETURN
      END
