      SUBROUTINE PARLAY(NXCODE,NRCCOD,NXCELL)
 
C     *************************************************************************
C
C     PARLAY
C     ======
C
C     AUTHOR
C     ------
C     R.S.CANT  --  CAMBRIDGE UNIVERSITY ENGINEERING DEPARTMENT
C
C     CHANGE RECORD
C     -------------
C     10-SEP-2014:  CREATED
C
C     DESCRIPTION
C     -----------
C     DNS CODE HAMISH
C     EXCHANGES STENCIL LAYER DATA BETWEEN PROCESSORS
C
C     *************************************************************************


C     GLOBAL DATA
C     ===========
C     -------------------------------------------------------------------------
      INCLUDE 'com_hamish.h'
C     -------------------------------------------------------------------------


C     ARGUMENTS
C     =========
      INTEGER NXCODE(NINDMX,NREMAX)
      INTEGER NRCCOD(NREMAX)
      INTEGER NXCELL


C     LOCAL DATA
C     ==========
      INTEGER NRRECV(NINDMX,NREMAX)
      INTEGER NRRCOD(NREMAX)
      INTEGER MCRUN(NINDMX),MCNXT(NINDMX)
      INTEGER NXSEND(NPROMX),NXRECV(NPROMX)
      INTEGER NMSEND(NPROMX),NMRECV(NPROMX)
      INTEGER NDSEND(NPROMX),NDRECV(NPROMX)
      INTEGER NBSEND(NPROMX),NBRECV(NPROMX)
      INTEGER JRCELL,JRLEVL,KRCELL,KRLEVL,KOFSET,KLEVLX,KRCELX
      INTEGER JPROC,JPROP1,NMCOMP
      INTEGER MOCTLO,NXRCEL
      CHARACTER*1 CFOUND,CFXTND

C     DIAGNOSTICS
      INTEGER LPROC

C     =========================================================================

C     On entry:
C     --------

C     Arguments:
C     NXCODE contains the M-code of each requested cell
C     NRCCOD contains the best-estimate status code for the requested cell
C            (zero on entry)
C     NXCELL number of requested cells in this layer

C     On exit:
C     -------
C     Arguments:
C     NXCODE contains the M-code of each requested cell (unchanged)
C     NRCCOD contains the actual status code for the requested cell
C     NXCELL number of requested cells in this layer (unchanged)
C
C     =========================================================================


C     BEGIN
C     =====

C     =========================================================================

C     DIAGNOSTICS
      LPROC = 20

CC     DIAGNOSTICS
C      IF(IPROC.EQ.LPROC)THEN
C        WRITE(6,'("PARLAY",2I5)')IPROC,NXCELL
C      ENDIF


C     GET THE ATTRIBUTES OF THE REMOTE CELLS
C     --------------------------------------

C     PARTITION THE LIST OF REMOTE CELLS
      DO JPROP1 = 1, NPROC
        NXSEND(JPROP1) = 0
        NXRECV(JPROP1) = 0
      ENDDO

      JPROC = 0
      JPROP1 = 1
      CALL MCRTBL(MCNXT,NTABLE,NPROMX,JPROC)
      CALL MCGLVL(MCNXT,KRLEVL)

      DO JRCELL = 1,NXCELL

        CALL MCRTRV(MCRUN,NXCODE,NREMAX,JRCELL)
1000    CONTINUE
          CALL MCCOML(MCRUN,MCNXT,KRLEVL,NMCOMP)
          IF(NMCOMP.GT.0)THEN
            JPROC = JPROP1
            JPROP1 = JPROP1 + 1
            CALL MCRTBL(MCNXT,NTABLE,NPROMX,JPROC)
            CALL MCGLVL(MCNXT,KRLEVL)
            GOTO 1000
          ENDIF
C       END OF LOOP 1000
        NXSEND(JPROP1) = NXSEND(JPROP1) + 1

      ENDDO

CC     DIAGNOSTICS
C      IF(IPROC.EQ.LPROC)THEN
C        WRITE(6,'("PARLAY",2I5)')IPROC,NPROC
C        DO JPROP1 = 1, NPROC
C          WRITE(6,'("PARLAY",2I5)')JPROP1,NXSEND(JPROP1)
C        ENDDO
C      ENDIF

C     -------------------------------------------------------------------------

C     EXCHANGE NUMBERS OF CELLS
      CALL P_ATOI(NXSEND,NPROMX,1,NXRECV,NPROMX,1)

C     TOTAL NUMBER OF CELLS TO RECEIVE
      NXRCEL = 0
      DO JPROP1 = 1,NPROC
        NXRCEL = NXRCEL + NXRECV(JPROP1)
      ENDDO

CC     DIAGNOSTICS
C      IF(IPROC.EQ.LPROC)THEN
C        WRITE(6,'(2I5)')IPROC,NPROC
C        DO JPROP1 = 1,NPROC
C          WRITE(6,'(3I5)')JPROP1,NXSEND(JPROP1),NXRECV(JPROP1)
C        ENDDO
C        WRITE(6,'(I5)')NXRCEL
C      ENDIF

C     -------------------------------------------------------------------------

C     UPDATE PARALLEL TRANSFER PARTITION ARRAYS
      NMSEND(1) = 2*NXSEND(1)
      NMRECV(1) = 2*NXRECV(1)
      NBSEND(1) = 0
      NBRECV(1) = 0
      NDSEND(1) = 0
      NDRECV(1) = 0
      DO JPROP1 = 2,NPROC
        JPROC = JPROP1 - 1
        NMSEND(JPROP1) = 2*NXSEND(JPROP1)
        NMRECV(JPROP1) = 2*NXRECV(JPROP1)
        NBSEND(JPROP1) = NBSEND(JPROC) + NXSEND(JPROC)
        NBRECV(JPROP1) = NBRECV(JPROC) + NXRECV(JPROC)
        NDSEND(JPROP1) = NDSEND(JPROC) + NMSEND(JPROC)
        NDRECV(JPROP1) = NDRECV(JPROC) + NMRECV(JPROC)
      ENDDO

CC     DIAGNOSTICS
C      IF(IPROC.EQ.LPROC)THEN
C        DO JPROP1 = 1,NPROC
C          WRITE(6,'(10I5)')JPROP1,NMSEND(JPROP1),NMRECV(JPROP1),
C     +                            NBSEND(JPROP1),NBRECV(JPROP1),
C     +                            NDSEND(JPROP1),NDRECV(JPROP1)
C        ENDDO
C        WRITE(6,'(I5)')NXRCEL
C      ENDIF

C     -------------------------------------------------------------------------

C     EXCHANGE M-CODES
      CALL P_A2IV(NXCODE,NREMAX,NMSEND,NDSEND,
     +            NRRECV,NREMAX,NMRECV,NDRECV,NPROC)

C     -------------------------------------------------------------------------

C     RUN THROUGH ALL RECEIVED M-CODES
      DO JRCELL = 1, NXRCEL

C       FETCH THE M-CODE
        CALL MCRTRV(MCRUN,NRRECV,NREMAX,JRCELL)

C       GET THE LEVEL
        CALL MCGLVL(MCRUN,JRLEVL)

C       DIAGNOSTICS
        IF(IPROC.EQ.LPROC)THEN
          WRITE(6,'("PARLAY",3I5)')IPROC,JRCELL,JRLEVL
          CALL MCRITE(MCRUN)
        ENDIF

C       SEARCH FOR THE CORRESPONDING CELL
        CALL OCFIND(NOCHLD,COCODE,NOCTMX,MCRUN,KRLEVL,KRCELL,CFOUND)

C       CHECK FINDINGS
        IF(CFOUND.EQ.CHTWIG)THEN

C         ---------------------------------------------------------------------

C         CELL IS LOCAL
C         -------------
C         CHECK THE LEVEL
          IF(KRLEVL.EQ.JRLEVL)THEN

C           CLEAN FACE
C           ----------
C           SAVE THE ATTRIBUTE
            NRRCOD(JRCELL) = NCLEAN

          ELSEIF(KRLEVL.EQ.JRLEVL-1)THEN

C           h-2h TRANSITION
C           ---------------
C           SAVE THE ATTRIBUTE
            NRRCOD(JRCELL) = NHTO2H

          ELSE

C           ERROR CONDITION - received neighbour cell not found'
C           ---------------
            CALL ERHAND(3,11,4)

          ENDIF

C         ---------------------------------------------------------------------

        ELSEIF(CFOUND.EQ.CHNRML)THEN

C         --------------------------------------------------------------------- 

C         CELL NOT FOUND AT EXPECTED LEVEL
C         --------------------------------
C         POSSIBLE 2h-h TRANSITION

C         RUN THROUGH THE NEIGHBOURING h-CELLS
          DO KOFSET = 1,NOFSET

C           EXTEND M-CODE
            CALL MCCOPY(MCRUN,MCNXT)
            MOCTLO = KOFSET
            CALL MCHIRE(MCNXT,MOCTLO)

C           SEARCH FOR THE EXTENDED M-CODE
            CALL OCFIND(NOCHLD,COCODE,NOCTMX,MCNXT,KLEVLX,KRCELX,CFXTND)

C           CHECK FINDINGS
            IF(CFXTND.EQ.CHTWIG)THEN

C             2h-h TRANSITION
C             ---------------
C             SAVE THE ATTRIBUTE
              IF(KOFSET.EQ.1)NRRCOD(JRCELL) = N2HTOH

            ELSEIF(CFXTND.EQ.CHNRML)THEN

C             RECURSIVE 2h-h TRANSITION
C             --------------------------
C             SAVE THE ATTRIBUTE
              IF(KOFSET.EQ.1)NRRCOD(JRCELL) = N2HTOH

            ELSEIF(CFXTND.EQ.CHPARL)THEN

C             RECURSIVE 2h-h TRANSITION
C             --------------------------
C             SAVE THE ATTRIBUTE
              IF(KOFSET.EQ.1)NRRCOD(JRCELL) = N2HTOH

            ELSE

C             ERROR CONDITION - received 2h-h extended cell not found
C             ---------------
C             DIAGNOSTICS
              IF(IPROC.EQ.LPROC)THEN
                WRITE(6,'("PARLAY2hh",3I5,A)')IPROC,JRCELL,JRLEVL,CFXTND
                CALL MCRITE(MCNXT)
              ENDIF

              CALL ERHAND(3,12,4)

            ENDIF
C           CHECK FINDINGS

          ENDDO
C         RUN THROUGH THE NEIGHBOURING h-CELLS

C         ---------------------------------------------------------------------

        ELSE

C         ---------------------------------------------------------------------

C         ERROR CONDITION - received cell not found
C         ---------------
          CALL ERHAND(3,13,4)

C         ---------------------------------------------------------------------

        ENDIF
C       END OF CHECK FINDINGS

C       -----------------------------------------------------------------------

      ENDDO
C     END OF RUN THROUGH ALL RECEIVED M-CODES
C     NOTE THAT NRRCOD NOW CONTAINS CELL STATUS CODES

C     =========================================================================

C     EXCHANGE CELL STATUS CODES
      CALL P_A2IV(NRRCOD,NREMAX,NXRECV,NBRECV,
     +            NRCCOD,NREMAX,NXSEND,NBSEND,NPROC)

C     =========================================================================


      RETURN
      END
