      SUBROUTINE PTABLE(MCMAX)
 
C     *************************************************************************
C
C     PTABLE
C     ======
C
C     AUTHOR
C     ------
C     R.S.CANT  --  CAMBRIDGE UNIVERSITY ENGINEERING DEPARTMENT
C
C     CHANGE RECORD
C     -------------
C     19-AUG-2008:  CREATED
C
C     DESCRIPTION
C     -----------
C     DNS CODE HAMISH
C     BUILDS THE PARTITION INTERVAL TABLE
C
C     *************************************************************************


C     GLOBAL DATA
C     ===========
C     -------------------------------------------------------------------------
      INCLUDE 'com_hamish.h'
C     -------------------------------------------------------------------------


C     ARGUMENTS
C     =========
      INTEGER MCMAX(NINDMX)


C     LOCAL DATA
C     ==========
      INTEGER NTLOCL(NTLSIZ)
      INTEGER IINDEX,JPROC,KPROC

C     DIAGNOSTICS
      INTEGER LPROC

C     BEGIN
C     =====

C     =========================================================================

C     DIAGNOSTICS
      LPROC = 20

C     DIAGNOSTICS
      IF(IPROC.EQ.LPROC)THEN
        WRITE(6,*)'In PTABLE',IPROC
        CALL MCRITE(MCMAX)
      ENDIF

C     SEND LOCAL UPPER-LIMIT M-CODE AND GATHER ALL THE OTHERS
      CALL P_GTHI(MCMAX,NINDMX,NTLOCL,NTLSIZ)

C     FILL THE TABLE
      KPROC = 0
      DO JPROC = 0, NPRM1
        DO IINDEX = 1,NINDMX
          KPROC = KPROC + 1
          NTABLE(IINDEX,JPROC) = NTLOCL(KPROC)
        ENDDO
      ENDDO

C     DIAGNOSTICS
      IF(IPROC.EQ.LPROC)THEN
        DO JPROC = 0, NPRM1
          CALL MCRTBL(MCMAX,NTABLE,NPROMX,JPROC)
          CALL MCRITE(MCMAX)
        ENDDO
      ENDIF

C     =========================================================================


      RETURN
      END
