      SUBROUTINE REFACT(NTREFN,NINDPR,NCREFN)
 
C     *************************************************************************
C
C     REFACT
C     ======
C
C     AUTHOR
C     ------
C     R.S.CANT  --  CAMBRIDGE UNIVERSITY ENGINEERING DEPARTMENT
C
C     CHANGE RECORD
C     -------------
C     16-NOV-2008:  CREATED
C
C     DESCRIPTION
C     -----------
C     DNS CODE HAMISH
C     CARRIES OUT REFINEMENT ACTIONS
C
C     *************************************************************************


C     GLOBAL DATA
C     ===========
C     -------------------------------------------------------------------------
      INCLUDE 'com_hamish.h'
C     -------------------------------------------------------------------------


C     ARGUMENTS
C     =========
      INTEGER NTREFN(NINDMX,NRDMAX)
      INTEGER NINDPR(NRDMAX)
      INTEGER NCREFN


C     LOCAL DATA
C     ==========
      INTEGER MCRUN(NINDMX)
      INTEGER ICREFN,ICBASE,INCODE,INCELL,IOFSET
      INTEGER MLEVEL,MEXTRA
C      CHARACTER*1 CHATTR

C     DIAGNOSTICS
      INTEGER LPROC


C     BEGIN
C     =====

C     DIAGNOSTICS
      LPROC = 20

CC     DIAGNOSTICS
C      IF(IPROC.EQ.LPROC)WRITE(6,*)'In REFACT:',ITIME,NCREFN

C     =========================================================================

C     CARRY OUT THE REFINEMENT ACTIONS
C     --------------------------------

CC     DIAGNOSTICS
C      IF(IPROC.EQ.LPROC)THEN
C        DO ICREFN = 1, NCREFN
C          CALL MCRTRV(MCRUN,NTREFN,NRDMAX,ICREFN)
C          CALL MCGLVL(MCRUN,MLEVEL)
C          ICBASE = NINDPR(ICREFN)
C          WRITE(6,'(4I5)')ICREFN,ICBASE,MLEVEL,NRSTAT(ICBASE)
C        ENDDO
C        DO ICBASE = 1, NCELL
C          CALL MCRTRV(MCRUN,NMCODE,NSIZMX,ICBASE)
C          CALL MCGLVL(MCRUN,MLEVEL)
C          WRITE(6,'(4I5)')ICBASE,NCOCEL(ICBASE),
C     +                           MLEVEL,NRSTAT(ICBASE)
C        ENDDO
C      ENDIF

C     RUN THROUGH THE REFINEMENT LIST
      DO ICREFN = 1,NCREFN

C       RETRIEVE THE M-CODE OF THE CELL TO REFINE
        CALL MCRTRV(MCRUN,NTREFN,NRDMAX,ICREFN)

CC       UNSET THE ATTRIBUTE OF THE CURRENT OCTREE ENTRY
C        CHATTR = CHUNST
C        CALL OCSATT(NOCHLD,COCODE,NOCTMX,MCRUN,CHATTR)
C
CC       ADD A NEW OCTANT
C        CALL OCTADD(NOCPAR,NOCHLD,COCODE,NOCTMX,NOCHWM,MCRUN,CHATTR)

C       INCREMENT THE LEVEL OF THE BASE M-CODE
        MEXTRA = 0
        CALL MCHIRE(MCRUN,MEXTRA)
        CALL MCGLVL(MCRUN,MLEVEL)

C       ADD A NEW LEAF TO THE OCTREE
C       POINTING TO THE ORIGINAL CELL
C       WHOSE LEVEL HAS JUST BEEN INCREMENTED
        ICBASE = NINDPR(ICREFN)
        CALL MCSTOR(MCRUN,NMCODE,NSIZMX,ICBASE)
C        CALL OCLEAF(NOCHLD,COCODE,NOCTMX,MCRUN,ICBASE,CHATTR)

C       CHECK AND RESET THE CELL REFINEMENT STATUS
        IF(NRSTAT(ICBASE).EQ.NRNULL)THEN

          NRSTAT(ICBASE) = NRRPAR

        ELSE IF(NRSTAT(ICBASE).EQ.NRDPAR)THEN

          NRSTAT(ICBASE) = NRDRTN

        ELSE

C         ERROR STATUS
C         DIAGNOSTICS
          WRITE(6,*)'REFACT: cell refinement status error',
     +               ICBASE,NRSTAT(ICBASE)

        ENDIF

C       MAKE THE NEW CELLS
        DO IOFSET = 1,NOFSET

C         NEW M-CODE
          INCODE = NNCODE + IOFSET
          CALL MCINCR(MCRUN)
          CALL MCSTOR(MCRUN,NMCODE,NSIZMX,INCODE)

C         NEW CELL
          INCELL = NCELL + IOFSET
C          CALL OCLEAF(NOCHLD,COCODE,NOCTMX,MCRUN,INCELL,CHATTR)

C         NEW CELL OLD CELL INDEX
          NCOCEL(INCELL) = 0

C         NEW CELL REFINEMENT STATUS CODE
          NRSTAT(INCELL) = NRRCHL

        ENDDO

CC       ANY REMAINING OCTETS ARE OUTSIDE THE DOMAIN
C        CHATTR = CHOUTC
C        DO IOFSET = NOFSP1,7
C          CALL MCINCR(MCRUN)
C          CALL OCSATT(NOCHLD,COCODE,NOCTMX,MCRUN,CHATTR)
C        ENDDO

C       UPDATE THE HIGH-WATER MARKS
        NNCODE = NNCODE + NOFSET
        NCELL = NCELL + NOFSET

      ENDDO

CC     DIAGNOSTICS
C      IF(IPROC.EQ.LPROC)WRITE(6,*)NCELL

C     =========================================================================


      RETURN
      END
