      SUBROUTINE RANGET(STARAY)
 
C     *************************************************************************
C
C     RANGET
C     ======
C
C     AUTHOR
C     ------
C     R.S.CANT
C
C     CHANGE RECORD
C     -------------
C     27-APR-2012:  CREATED
C
C     DESCRIPTION
C     -----------
C     GETS THE STATE OF UNIVARATE UNIFORM RANDOM NUMBER GENERATOR RANUNI
C     BASED ON NUMERICAL RECIPES ROUTINE 'RAN1'
C
C     REFERENCES
C     ----------
C     NUMERICAL RECIPES, 1st Ed, CUP (1986), pp195-199
C
C     *************************************************************************


C     PARAMETER
C     =========
      INTEGER NSTRMX
      PARAMETER(NSTRMX = 100)


C     ARGUMENT
C     ========
      DOUBLE PRECISION STARAY(NSTRMX)


C     SAVED DATA
C     ==========
      INTEGER NSHUFF
      PARAMETER(NSHUFF = 97)
      INTEGER INTX1,INTX2,INTX3
      DOUBLE PRECISION SHUFFL(NSHUFF)
      COMMON/RANCOM/SHUFFL,INTX1,INTX2,INTX3


C     LOCAL DATA
C     ==========
      INTEGER IC


C     BEGIN
C     =====
      DO IC = 1,NSHUFF
        STARAY(IC) = SHUFFL(IC)
      ENDDO
      STARAY(NSHUFF+1) = REAL(INTX1)
      STARAY(NSHUFF+2) = REAL(INTX2)
      STARAY(NSHUFF+3) = REAL(INTX3)


      RETURN
      END
