      SUBROUTINE STEPPR
 
C     *************************************************************************
C
C     STEPPR
C     ======
C
C     AUTHOR
C     ------
C     R.S.CANT  --  CAMBRIDGE UNIVERSITY ENGINEERING DEPARTMENT
C
C     CHANGE RECORD
C     -------------
C     01-JAN-2008:  CREATED
C
C     DESCRIPTION
C     -----------
C     DNS CODE HAMISH
C     TIME STEPPING OF THE SOLUTION
C
C     *************************************************************************


C     GLOBAL DATA
C     ===========
C     -------------------------------------------------------------------------
      INCLUDE 'com_hamish.h'
C     -------------------------------------------------------------------------


C     LOCAL DATA
C     ==========
      INTEGER JTIME,JRKSTP

C     DIAGNOSTICS
      INTEGER LPROC


C     BEGIN
C     =====

C     DIAGNOSTICS
      LPROC = 20

C     DIAGNOSTICS
      IF(IPROC.EQ.LPROC)WRITE(6,*)'In STEPPR'

C     =========================================================================
 
C     TIME STEP LOOP
C     ==============
      DO JTIME = NTIME1,NTIME2

C       =======================================================================

C       TIME STEP INDEX
        ITIME = JTIME

C       =======================================================================

C       FILTER
C       ======
C        CALL REFILT

C       =======================================================================

C       DIAGNOSTICS
        IF(IPROC.EQ.LPROC)WRITE(6,*)'Call ADAPTM',ITIME

C       ADJUST THE MESH
C       ===============
        CALL ADAPTM

C       =======================================================================

C       RUNGE-KUTTA SUBSTEPS
C       ====================

C       STANDARD SUBSTEPS
C       -----------------
        DO JRKSTP = 1,NRKSM1

          IRKSTP = JRKSTP
        
C         ELAPSED RK PSEUDO-TIME
          RKTIME = ETIME + RKTIM(IRKSTP)

C         DIAGNOSTICS
          IF(IPROC.EQ.LPROC)
     +      WRITE(6,'("RK",2I5,2(1PE12.4))')ITIME,IRKSTP,ETIME,RKTIME

C         PARALLEL DATA TRANSFER
          CALL PARFER

C         EVALUATE RHS FOR ALL VARIABLES
          CALL RHSCEL

C         RUNGE-KUTTA ADVANCEMENT
          CALL RKSTEP

CC         DIAGNOSTICS
C          IF(IPROC.EQ.LPROC)
C     +      WRITE(6,'("RK",2I5,4(1PE12.4))')ITIME,IRKSTP,ETIME,RKTIME,
C     +                                      URUN(1,55),URUN(2,55)

C         SYNCHRONISE THE TIME-DEPENDENT BCS
          CALL BCSYNC

        ENDDO

C       =======================================================================
  
C       LAST SUBSTEP IS DIFFERENT
C       -------------------------
        IRKSTP = NRKSTP

C       ELAPSED RK PSEUDO-TIME
        RKTIME = ETIME + RKTIM(IRKSTP)

C       DIAGNOSTICS
        IF(IPROC.EQ.LPROC)
     +    WRITE(6,'("RK",2I5,2(1PE12.4))')ITIME,IRKSTP,ETIME,RKTIME

C       PARALLEL DATA TRANSFER
        CALL PARFER

C       EVALUATE RHS FOR ALL VARIABLES
        CALL RHSCEL

C       RUNGE-KUTTA ADVANCEMENT
        CALL RKLAST

C       SYNCHRONISE THE TIME-DEPENDENT BCS
        CALL BCSYNC

C       =======================================================================

C       UPDATE THE ELAPSED TIME
C       =======================
        ETIME = ETIME + TSTEP

C       =======================================================================

C       ADJUST THE TIME STEP
C       ====================
        CALL ADAPTT

C       =======================================================================

C       PROCESS THE RESULTS
C       ===================
        CALL OUTPUT

C       =======================================================================

      ENDDO
C     END OF TIME STEP LOOP

C     =========================================================================


      RETURN
      END
